/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ProyeccionPensionados;

/**
 *
 * @author Antonio-Alcalde
 */

import Librerias.LecturaArchivoTxt;

public class Constantes {

    public Constantes(String ruta, String archivo)
    {
        LecturaArchivoTxt latxt = new LecturaArchivoTxt();
        
        Object obj[] = latxt.leerArchivoParametros(ruta, archivo);
        

        ANIO_BASE = Integer.valueOf((String)obj[0]).intValue();
        DIAS_ANUAL = Integer.valueOf((String)obj[1]).intValue();
        EDAD_MINIMA_ASEGURADO = Integer.valueOf((String)obj[2]).intValue();
        EDAD_MAXIMA_ASEGURADO = Integer.valueOf((String)obj[3]).intValue();
        ANIOS_PROYECCION = Integer.valueOf((String)obj[4]).intValue();
        EDAD_MIN_PROYECTADA = Integer.valueOf((String)obj[5]).intValue();
        EDAD_MAX_PROYECTADA = Integer.valueOf((String)obj[6]).intValue();
        SALARIO_MINIMO_ANIO_BASE = Double.valueOf((String)obj[7]).doubleValue();
        VECES_SMGDF = Double.valueOf((String)obj[8]).doubleValue();
        AYUDAS = Double.valueOf((String)obj[9]).doubleValue();
        PORC_CUANTIA_VIUDEZ = Double.valueOf((String)obj[10]).doubleValue();
        DECIMO_CUARTO = Double.valueOf((String)obj[11]).doubleValue();
        PORC_CUANTIA_HUERF_ASC = Double.valueOf((String)obj[12]).doubleValue();
        APORTACION_RCV = Double.valueOf((String)obj[13]).doubleValue();
        APORTACION_VIVIENDA = Double.valueOf((String)obj[14]).doubleValue();
        ASEG_APORTAN_SIN_CREDITO = Double.valueOf((String)obj[15]).doubleValue();
        PORC_CUANTIA_RT = Double.valueOf((String)obj[16]).doubleValue();
        PORC_CUANTIA_VIUDEZ_RT = Double.valueOf((String)obj[17]).doubleValue();
        NUMERO_CTIA_RT = Double.valueOf((String)obj[18]).doubleValue();
        PORC_VAL_IGUAL_100H = Double.valueOf((String)obj[19]).doubleValue();
        PORC_VAL_MENOR_100H = Double.valueOf((String)obj[20]).doubleValue();
        PORC_VAL_MENOR_50H = Double.valueOf((String)obj[21]).doubleValue();
        PORC_VAL_IGUAL_100M = Double.valueOf((String)obj[22]).doubleValue();
        PORC_VAL_MENOR_100M = Double.valueOf((String)obj[23]).doubleValue();
        PORC_VAL_MENOR_50M = Double.valueOf((String)obj[24]).doubleValue();
        PORC_COSTO_UNITARIO = Double.valueOf((String)obj[25]).doubleValue();
        CRECIMIENTO_REAL = Double.valueOf((String)obj[26]).doubleValue();
        PORC_VIUDEZIV_STOCK = Double.valueOf((String)obj[27]).doubleValue();
        PORC_ASIG_FAMILIARES = Double.valueOf((String)obj[28]).doubleValue();
        SALARIO_MIN_STOCK = Double.valueOf((String)obj[29]).doubleValue();
        DIRECTORIO_DATOS_ENTRADA = String.valueOf(obj[30]);
        DIRECTORIO_FORMATO = String.valueOf(obj[31]);
        DIRECTORIO_SALIDA = String.valueOf(obj[32]);
        NOMBRE_ARCHIVO_ENTRADA = String.valueOf(obj[33]);
        NOMBRE_ARCHIVO_SALIDA_IV = String.valueOf(obj[34]);
        NOMBRE_ARCHIVO_SALIDA_RT = String.valueOf(obj[35]);
        NOMBRE_ARCHIVO_FORMATO_IV = String.valueOf(obj[36]);
        NOMBRE_ARCHIVO_FORMATO_RT = String.valueOf(obj[37]);

    }

    public Constantes()
    {
    }

    public static final char HOMBRE = 'H';
    public static final char MUJER = 'M';
    public static final String INVALIDEZ = "IV";
    public static final String RIESGO_TRABAJO = "RT";
    public static int DIAS_ANUAL = 365;
    public static int EDAD_MAX_PROYECTADA = 110;
    public static int EDAD_MIN_PROYECTADA = 15;
    public static int EDAD_MAXIMA_ASEGURADO = 89;
    public static int EDAD_MINIMA_ASEGURADO = 15;
    public static int ANIO_BASE = 2009;
    public static int ANIOS_PROYECCION = 100;
    public static double SALARIO_MINIMO_ANIO_BASE;
    public static double VECES_SMGDF = 1.5D;
    public static double AYUDAS = 30.4166666666667D;
    public static double PORC_CUANTIA_VIUDEZ = 0.8D;
    public static double PORC_CUANTIA_VIUDEZ_RT = 0.4D;
    public static double DECIMO_CUARTO = 1.11D;
    public static double PORC_CUANTIA_HUERF_ASC = 0.2D;
    public static double PORC_CUANTIA_RT= 0.7D;
    public static double NUMERO_CTIA_RT = 0.0410958904109589D;

    public static double PORC_VAL_IGUAL_100H = 1D;
    public static double PORC_VAL_MENOR_100H = 0.6670D;
    public static double PORC_VAL_MENOR_50H = 0.2437D;

    public static double PORC_VAL_IGUAL_100M = 1D;
    public static double PORC_VAL_MENOR_100M = 0.6794D;
    public static double PORC_VAL_MENOR_50M = 0.2775D;

    public static double APORTACION_RCV = 0.045D;
    public static double APORTACION_VIVIENDA = 0.05D;
    public static double ASEG_APORTAN_SIN_CREDITO = 0.75D;

    public static double PORC_COSTO_UNITARIO = 0.025D;
    public static double CRECIMIENTO_REAL = 0.0D;
    public static double PORC_VIUDEZIV_STOCK = 0.90D;
    public static double PORC_ASIG_FAMILIARES = 0.10D;
    public static double SALARIO_MIN_STOCK = 54.8D;

    public static String DIRECTORIO_DATOS_ENTRADA = "../";
    public static String DIRECTORIO_FORMATO = "../";
    public static String DIRECTORIO_SALIDA = "../";
    public static String NOMBRE_ARCHIVO_ENTRADA = "";
    public static String NOMBRE_ARCHIVO_SALIDA_IV = "";
    public static String NOMBRE_ARCHIVO_SALIDA_RT = "";
    public static String NOMBRE_ARCHIVO_FORMATO_IV = "";
    public static String NOMBRE_ARCHIVO_FORMATO_RT = "";
    
    
    


}
