/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ProyeccionPensionados;


/**
 *
 * @author Antonio-Alcalde
 */
import Librerias.FuncionesMatematicas;

public class CuentaIndividual {

    double[][] rcvProyectada;
    double[][] csProyectada;
    double[][] vivProyectada;
    double[][] salariosCSproy;

    double[] saldoPromRCVPensionados;
    double[] saldoPromCSPensionados;
    double[] saldoPromVivPensionados;

    double[] saldoCITempRCV = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempCS = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempViv = new double[Constantes.ANIOS_PROYECCION-1];

    double[] saldoCITempDefRCV = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempDefCS = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempDefViv = new double[Constantes.ANIOS_PROYECCION-1];

    double[] saldoCITempDefRCVIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempDefCSIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempDefVivIP100 = new double[Constantes.ANIOS_PROYECCION-1];

    double[] saldoCITempDefRCVIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempDefCSIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempDefVivIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];

    double[] saldoCITempDefRCVIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempDefCSIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempDefVivIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];

    double[] saldoCITempRCVIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempCSIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempVivIP100 = new double[Constantes.ANIOS_PROYECCION-1];

    double[] saldoCITempRCVIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempCSIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempVivIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];

    double[] saldoCITempRCVIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempCSIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    double[] saldoCITempVivIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];

    public void proyectarSaldosCuentaIndividual(double[][] asegVigentes,
                                                double[][] asegCotizan,
                                                double[][] asegNoCotizan,
                                                double[][] saldoRCV_L73,
                                                double[][] saldoCS_L73,
                                                double[][] saldoViv_L73,
                                                double[][] probSobAseg,
                                                double[]   proySalReales,
                                                double[]   proySalCuotaSocial,
                                                double     tasaBimestraRCVyCS,
                                                double     tasaBimestralVivienda,
                                                double     comisionSobSaldo){

        double[][] saldoRCV;
        double[][] saldoCuotaSocial;
        double[][] saldoVivienda;
        double[]   saldoPromRCVPensionados = new double[saldoRCV_L73.length];
        double[]   saldoPromCSPensionados = new double[saldoRCV_L73.length];
        double[]   saldoPromVivPensionados = new double[saldoRCV_L73.length];

        //Crean objetos a utilizar
        FuncionesMatematicas fm = new FuncionesMatematicas();


        /**********************************************
         * Obtenemos el saldo en la subcuenta de RCV. *
         *********************************************/
        saldoRCV = obtenerSaldosRCVyCuotaSocial(asegVigentes,
                                                asegCotizan,
                                                asegNoCotizan,
                                                saldoRCV_L73,
                                                probSobAseg,
                                                proySalReales,
                                                tasaBimestraRCVyCS,
                                                comisionSobSaldo,
                                                true);//Indicamos que es RCV
        this.rcvProyectada = saldoRCV;

        /*******************************************************
         * Obtenemos el saldo en la subcuenta de Cuota social. *
         *******************************************************/

        saldoCuotaSocial = obtenerSaldosRCVyCuotaSocial(asegVigentes,
                                                        asegCotizan,
                                                        asegNoCotizan,
                                                        saldoCS_L73,
                                                        probSobAseg,
                                                        proySalCuotaSocial,
                                                        tasaBimestraRCVyCS,
                                                        comisionSobSaldo,
                                                        false);//indicamos que es cuota social
        this.csProyectada = saldoCuotaSocial;

        /***************************************************
         * Obtenemos el saldo en la subcuenta de Vivienda. *
         ***************************************************/
        saldoVivienda = obtenerSaldoVivienda(asegVigentes,
                                             asegCotizan,
                                             asegNoCotizan,
                                             saldoViv_L73,
                                             probSobAseg,
                                             proySalReales,
                                             tasaBimestralVivienda);

        this.vivProyectada = saldoVivienda;

    }

    public void proyectarSaldosCtaIndPensionados(double[][] asegBase,
                                                double[][] asegCotizan,
                                                double[][] pensMitadAnio,
                                                double[][] saldoRCV_L73,
                                                double[][] saldoCS_L73,
                                                double[][] saldoViv_L73,
                                                double[]   proySalReales,
                                                double[]   proySalCuotaSocial,
                                                double     tasaBimestraRCVyCS,
                                                double     tasaBimestralVivienda,
                                                double     capAporBimRCVyCS,
                                                double     capAporBimViv,
                                                double     comisionSobSaldo){

        
        double[][] saldoAcumRCVPensionados;
        double[][] saldoAcumCSPensionados;
        double[][] saldoAcumVivPensionados;
        double[]   saldoPromRCVPensionados = new double[saldoRCV_L73.length];
        double[]   saldoPromCSPensionados = new double[saldoRCV_L73.length];
        double[]   saldoPromVivPensionados = new double[saldoRCV_L73.length];

        //Crean objetos a utilizar
        FuncionesMatematicas fm = new FuncionesMatematicas();

        /**************************************************************************************
         * Obtenemos el saldo promedio en la subcuenta de RCV de los pensionados en cada año. *
         **************************************************************************************/
        saldoAcumRCVPensionados = obtenerSaldoAcumuladoRCVyCSPensionados(asegBase,
                                                                         asegCotizan,
                                                                         saldoRCV_L73,
                                                                         proySalReales,
                                                                         tasaBimestraRCVyCS,
                                                                         comisionSobSaldo,
                                                                         capAporBimRCVyCS,
                                                                         true);//Indicamos que es RCV        

        //Obtenemos el saldo promedio en RCV de los pensionados definitivos
        for(int edad=0;edad<saldoAcumRCVPensionados.length;edad++){
            saldoPromRCVPensionados[edad] = fm.sumaProducto(saldoAcumRCVPensionados[edad], pensMitadAnio[edad])/1000000D;
            
        }

        this.saldoPromRCVPensionados = saldoPromRCVPensionados;
        
        
        /************************************************************************************************
         * Obtenemos el saldo promedio en la subcuenta de Cuota Social de los pensionados en cada año.  *
         ***********************************************************************************************/
        saldoAcumCSPensionados = obtenerSaldoAcumuladoRCVyCSPensionados(asegBase,
                                                                        asegCotizan,
                                                                        saldoCS_L73,
                                                                        proySalCuotaSocial,
                                                                        tasaBimestraRCVyCS,
                                                                        comisionSobSaldo,
                                                                        capAporBimRCVyCS,
                                                                        false);//indicamos que no es RCV, es CS

        //Obtenemos el saldo promedio en Cuota Social de los pensionados definitivos
        for(int edad=0;edad<saldoAcumCSPensionados.length;edad++){
            saldoPromCSPensionados[edad] = fm.sumaProducto(saldoAcumCSPensionados[edad], pensMitadAnio[edad])/1000000D;
        }

        this.saldoPromCSPensionados = saldoPromCSPensionados;

        /********************************************************************************************
         * Obtenemos el saldo promedio en la subcuenta de Vivienda de los pensionados en cada año.  *
         ********************************************************************************************/
        saldoAcumVivPensionados = obtenerSaldoAcumuladoVivPensionados(asegBase,
                                                                      asegCotizan,
                                                                      saldoViv_L73,
                                                                      proySalReales,
                                                                      tasaBimestralVivienda,
                                                                      capAporBimViv);

        //Obtenemos el saldo promedio en Vivienda de los pensionados definitivos
        for(int edad=0;edad<saldoAcumCSPensionados.length;edad++){
            saldoPromVivPensionados[edad] = fm.sumaProducto(saldoAcumVivPensionados[edad], pensMitadAnio[edad])/1000000D;
        }

        this.saldoPromVivPensionados = saldoPromVivPensionados;




    }

    public void proyectarSaldosCtaIndPensionadosTemp(double[][] asegBase,
                                                     double[][] asegCotizan,
                                                     double[][] pensMitadAnio,
                                                     double[][] pensTempFinalAnio,
                                                     double[][] saldoRCV_L73,
                                                     double[][] saldoCS_L73,
                                                     double[][] saldoViv_L73,
                                                     double[][] distViudas,
                                                     double[][] distHuerfanos,
                                                     double[][] distAscendientes,
                                                     double[][] nvasViudas,
                                                     double[][] nvosHuerf,
                                                     double[][] nvasAsc,
                                                     double[]   proySalReales,
                                                     double[]   proySalCuotaSocial,
                                                     double[]   tasaBimestraRCVyCS,
                                                     double[]   tasaBimestralVivienda,
                                                     double[]   tasaAnualRCVyCS,
                                                     double[]   tasaAnualViv,
                                                     double[]   comisionSobSaldo,
                                                     double     capAporBimRCVyCS,
                                                     double     capAporBimViv,
                                                     int        anioProy,
                                                     String     pension){


        double[][] saldoAcumRCVPensionados;
        double[][] saldoAcumCSPensionados;
        double[][] saldoAcumVivPensionados;

        /**double[]   saldoPromRCVPensionados = new double[saldoRCV_L73.length];
        double[]   saldoPromCSPensionados = new double[saldoRCV_L73.length];
        double[]   saldoPromVivPensionados = new double[saldoRCV_L73.length];*/

        //Temporales
        double[][] invalidosTemporalesRCV = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] invalidosTemporalesCS = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] invalidosTemporalesViv = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];

        double[][] derivadasInvalidosTemporalesRCV = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] derivadasInvalidosTemporalesCS = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] derivadasInvalidosTemporalesViv = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];

        double[][] viudasTemporalesRCV = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] huerfanosTemporalesRCV = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] ascendientesTemporalesRCV = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];

        double[][] viudasTemporalesCS = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] huerfanosTemporalesCS = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] ascendientesTemporalesCS = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];

        double[][] viudasTemporalesViv = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] huerfanosTemporalesViv = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[][] ascendientesTemporalesViv = new double[3][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];

        double[] invalidosTempPromRCV = new double[saldoRCV_L73.length];
        double[] invalidosTempPromCS = new double[saldoRCV_L73.length];
        double[] invalidosTempPromViv = new double[saldoRCV_L73.length];

        double porcViuda = (pension.equals("inv")?Constantes.PORC_CUANTIA_VIUDEZ:Constantes.PORC_CUANTIA_VIUDEZ_RT);



        //Crean objetos a utilizar
        FuncionesMatematicas fm = new FuncionesMatematicas();

        /**************************************************************************************
         * Obtenemos el saldo promedio en la subcuenta de RCV de los pensionados en cada año. *
         **************************************************************************************/
        saldoAcumRCVPensionados = obtenerSaldoAcumuladoRCVyCSPensionados(asegBase,
                                                                         asegCotizan,
                                                                         saldoRCV_L73,
                                                                         proySalReales,
                                                                         tasaBimestraRCVyCS[anioProy],
                                                                         comisionSobSaldo[anioProy],
                                                                         capAporBimRCVyCS,
                                                                         true);//Indicamos que es RCV       
      

        //Obtenemos el vector de la CI de RCV de los pensionados temporales
        for(int edad=0;edad<saldoAcumRCVPensionados.length;edad++){
            invalidosTempPromRCV[edad] =  (fm.sumaVector(pensMitadAnio[edad])== 0?0:
                                          (fm.sumaProducto(pensMitadAnio[edad], saldoAcumRCVPensionados[edad]))/fm.sumaVector(pensMitadAnio[edad]));            
        }

        /***********************************************
         * OBTENEMOS MATRIZ DE PENSIONADOS TEMPORALES  *
         ***********************************************/

        //Para el primer año de proyección
        for(int edad=1;edad<=invalidosTempPromRCV.length;edad++){
            invalidosTemporalesRCV[0][edad] = invalidosTempPromRCV[edad-1]*(Math.pow(1+tasaBimestraRCVyCS[(anioProy<tasaBimestraRCVyCS.length?anioProy:tasaBimestraRCVyCS.length-1)], 3))*(1-comisionSobSaldo[(anioProy<comisionSobSaldo.length?anioProy:comisionSobSaldo.length-1)]/2);
        }

        //Para el segundo año de proyección
        for(int edad=1;edad<invalidosTemporalesRCV[0].length;edad++){
            invalidosTemporalesRCV[1][edad] = invalidosTemporalesRCV[0][edad-1]*(1+tasaAnualRCVyCS[(anioProy+1<tasaAnualRCVyCS.length?anioProy+1:tasaAnualRCVyCS.length-1)])*(1-comisionSobSaldo[(anioProy+1<comisionSobSaldo.length?anioProy+1:comisionSobSaldo.length-1)]);
        }

        //Para el tercer año de proyección
        for(int edad=1;edad<invalidosTemporalesRCV[0].length;edad++){
            invalidosTemporalesRCV[2][edad] = invalidosTemporalesRCV[1][edad]*(Math.pow(1+tasaBimestraRCVyCS[(anioProy+2<tasaBimestraRCVyCS.length?anioProy+2:tasaBimestraRCVyCS.length-1)], 3))*(1-comisionSobSaldo[(anioProy+2<comisionSobSaldo.length?anioProy+2:comisionSobSaldo.length-1)]/2);
        }

        /*******************************************************************
         * Obtenemos a los pensionados temporales que pasan a definitivos. *
         *******************************************************************/

        (pension.equals("inv")?saldoCITempDefRCV:pension.equals("ip100")?saldoCITempDefRCVIP100:pension.equals("ipMenor100")?saldoCITempDefRCVIPMenor100:saldoCITempDefRCVIPMenor50)
                                [(anioProy+2<saldoCITempDefRCV.length?anioProy+2:saldoCITempDefRCV.length-1)] =
                                                            fm.sumaProducto(invalidosTemporalesRCV[2], pensTempFinalAnio[3])/1000000D;


        /*************************************************************************
         * OBTENEMOS MATRIZ DE PENSIONES DERIVADAS DE LA MUERTE DE PENSIONADOS   *
         *************************************************************************/
        //Para el primer año
        for(int edad=0;edad<invalidosTempPromRCV.length;edad++){
            derivadasInvalidosTemporalesRCV[0][edad] = invalidosTempPromRCV[edad] *
                                                       (Math.pow(1+(Math.pow(1+tasaAnualRCVyCS[(anioProy<tasaAnualRCVyCS.length?anioProy:tasaAnualRCVyCS.length-1)], 1D/12D)-1), 3)) *
                                                       (1-comisionSobSaldo[(anioProy<comisionSobSaldo.length?anioProy:comisionSobSaldo.length-1)]/4D);
        }

        //Para el segundo año de pryección
        for(int edad=0;edad<invalidosTemporalesRCV[0].length;edad++){
            derivadasInvalidosTemporalesRCV[1][edad] = invalidosTemporalesRCV[0][edad] *
                                                       (Math.pow(1+ tasaBimestraRCVyCS[(anioProy+1<tasaBimestraRCVyCS.length?anioProy+1:tasaBimestraRCVyCS.length-1)], 3D)) *
                                                       (1-comisionSobSaldo[(anioProy+1<comisionSobSaldo.length?anioProy+1:comisionSobSaldo.length-1)]/2D);
        }

        //Para el tercer año de proyección
        for(int edad=0;edad<invalidosTemporalesRCV[0].length;edad++){
            derivadasInvalidosTemporalesRCV[2][edad] = invalidosTemporalesRCV[1][edad] *
                                                       (Math.pow(1+(Math.pow(1+tasaAnualRCVyCS[(anioProy+2<tasaAnualRCVyCS.length?anioProy+2:tasaAnualRCVyCS.length-1)], 1D/12D)-1D), 3D)) *
                                                       (1-comisionSobSaldo[(anioProy+2<comisionSobSaldo.length?anioProy+2:comisionSobSaldo.length-1)]/4D);
        }

        /*****************************************************
         * OBTENEMOS MATRIZ DE PENSIONES DERIVADAS FINALES   *
         *****************************************************/

        //Obtenemos la cuenta individual de viudas
        for(int año=0;año<viudasTemporalesRCV.length;año++){
            for(int edad=0;edad<viudasTemporalesRCV[0].length;edad++){
                viudasTemporalesRCV[año][edad] = fm.sumaProducto(derivadasInvalidosTemporalesRCV[año], distViudas[edad]);
            }
        }

        //Obtenemos la cuenta individual de huerfanos
        for(int año=0;año<huerfanosTemporalesRCV.length;año++){
            for(int edad=0;edad<huerfanosTemporalesRCV[0].length;edad++){
                huerfanosTemporalesRCV[año][edad] = fm.sumaProducto(derivadasInvalidosTemporalesRCV[año], distHuerfanos[edad]);
            }
        }

        //Obtenemos la cuenta individual de ascendientes
        for(int año=0;año<ascendientesTemporalesRCV.length;año++){
            for(int edad=0;edad<ascendientesTemporalesRCV[0].length;edad++){
                ascendientesTemporalesRCV[año][edad] = fm.sumaProducto(derivadasInvalidosTemporalesRCV[año], distAscendientes[edad]);
            }
        }

        /***********************************************************
         * Obtenemos el vector final de cuenta individual de RCV   *
         **********************************************************/

        int indexVec = 0;
        
        for(int año=anioProy;año<=anioProy+2;año++){
                (pension.equals("inv")?saldoCITempRCV:pension.equals("ip100")?saldoCITempRCVIP100:pension.equals("ipMenor100")?saldoCITempRCVIPMenor100:saldoCITempRCVIPMenor50)
                                    [(año<saldoCITempRCV.length?año:saldoCITempRCV.length-1)] +=
                                                             ((fm.sumaProducto(viudasTemporalesRCV[indexVec], nvasViudas[indexVec]) * porcViuda) +
                                                             (fm.sumaProducto(huerfanosTemporalesRCV[indexVec], nvosHuerf[indexVec]) * 0.2D) +
                                                             (fm.sumaProducto(ascendientesTemporalesRCV[indexVec], nvasAsc[indexVec]) * 0.2D))/1000000D;
                indexVec++;
        }
        
        /************************************************************************************************
         * Obtenemos el saldo promedio en la subcuenta de Cuota Social de los pensionados en cada año.  *
         ***********************************************************************************************/
        saldoAcumCSPensionados = obtenerSaldoAcumuladoRCVyCSPensionados(asegBase,
                                                                        asegCotizan,
                                                                        saldoCS_L73,
                                                                        proySalCuotaSocial,
                                                                        tasaBimestraRCVyCS[anioProy],
                                                                        comisionSobSaldo[anioProy],
                                                                        capAporBimRCVyCS,
                                                                        false);//indicamos que no es RCV, es CS


        //Obtenemos el vector de la CI de RCV de los pensionados temporales
        for(int edad=0;edad<saldoAcumCSPensionados.length;edad++){
            invalidosTempPromCS[edad] =  (fm.sumaVector(pensMitadAnio[edad])== 0?0:
                                          (fm.sumaProducto(pensMitadAnio[edad], saldoAcumCSPensionados[edad]))/fm.sumaVector(pensMitadAnio[edad]));
        }

        /***********************************************
         * OBTENEMOS MATRIZ DE PENSIONADOS TEMPORALES  *
         ***********************************************/

        //Para el primer año de proyección
        for(int edad=1;edad<=invalidosTempPromCS.length;edad++){
            invalidosTemporalesCS[0][edad] = invalidosTempPromCS[edad-1]*(Math.pow(1+tasaBimestraRCVyCS[(anioProy<tasaBimestraRCVyCS.length?anioProy:tasaBimestraRCVyCS.length-1)], 3))*(1-comisionSobSaldo[(anioProy<comisionSobSaldo.length?anioProy:comisionSobSaldo.length-1)]/2);
        }

        //Para el segundo año de proyección
        for(int edad=1;edad<invalidosTemporalesCS[0].length;edad++){
            invalidosTemporalesCS[1][edad] = invalidosTemporalesCS[0][edad-1]*(1+tasaAnualRCVyCS[(anioProy+1<tasaAnualRCVyCS.length?anioProy+1:tasaAnualRCVyCS.length-1)])*(1-comisionSobSaldo[(anioProy+1<comisionSobSaldo.length?anioProy+1:comisionSobSaldo.length-1)]);
        }

        //Para el tercer año de proyección
        for(int edad=1;edad<invalidosTemporalesCS[0].length;edad++){
            invalidosTemporalesCS[2][edad] = invalidosTemporalesCS[1][edad]*(Math.pow(1+tasaBimestraRCVyCS[(anioProy+2<tasaBimestraRCVyCS.length?anioProy+2:tasaBimestraRCVyCS.length-1)], 3))*(1-comisionSobSaldo[(anioProy+2<comisionSobSaldo.length?anioProy+2:comisionSobSaldo.length-1)]/2);
        }

        /*******************************************************************
         * Obtenemos a los pensionados temporales que pasan a definitivos. *
         *******************************************************************/

        (pension.equals("inv")?saldoCITempDefCS:pension.equals("ip100")?saldoCITempDefCSIP100:pension.equals("ipMenor100")?saldoCITempDefCSIPMenor100:saldoCITempDefCSIPMenor50)
                            [(anioProy+2<saldoCITempDefCS.length?anioProy+2:saldoCITempDefCS.length-1)] =
                                    fm.sumaProducto(invalidosTemporalesCS[2], pensTempFinalAnio[3])/1000000D;

        /*************************************************************************
         * OBTENEMOS MATRIZ DE PENSIONES DERIVADAS DE LA MUERTE DE PENSIONADOS   *
         *************************************************************************/
        //Para el primer año
        for(int edad=0;edad<invalidosTempPromCS.length;edad++){
            derivadasInvalidosTemporalesCS[0][edad] = invalidosTempPromCS[edad] *
                                                       (Math.pow(1+(Math.pow(1+tasaAnualRCVyCS[(anioProy<tasaAnualRCVyCS.length?anioProy:tasaAnualRCVyCS.length-1)], 1D/12D)-1), 3)) *
                                                       (1-comisionSobSaldo[(anioProy<comisionSobSaldo.length?anioProy:comisionSobSaldo.length-1)]/4D);
        }

        //Para el segundo año de pryección
        for(int edad=0;edad<invalidosTemporalesCS[0].length;edad++){
            derivadasInvalidosTemporalesCS[1][edad] = invalidosTemporalesCS[0][edad] *
                                                       (Math.pow(1+ tasaBimestraRCVyCS[(anioProy+1<tasaBimestraRCVyCS.length?anioProy+1:tasaBimestraRCVyCS.length-1)], 3D)) *
                                                       (1-comisionSobSaldo[(anioProy+1<comisionSobSaldo.length?anioProy+1:comisionSobSaldo.length-1)]/2D);
        }

        //Para el tercer año de proyección
        for(int edad=0;edad<invalidosTemporalesCS[0].length;edad++){
            derivadasInvalidosTemporalesCS[2][edad] = invalidosTemporalesCS[1][edad] *
                                                       (Math.pow(1+(Math.pow(1+tasaAnualRCVyCS[(anioProy+2<tasaAnualRCVyCS.length?anioProy+2:tasaAnualRCVyCS.length-1)], 1D/12D)-1D), 3D)) *
                                                       (1-comisionSobSaldo[(anioProy+2<comisionSobSaldo.length?anioProy+2:comisionSobSaldo.length-1)]/4D);
        }

        /*****************************************************
         * OBTENEMOS MATRIZ DE PENSIONES DERIVADAS FINALES   *
         *****************************************************/

        //Obtenemos la cuenta individual de viudas
        for(int año=0;año<viudasTemporalesCS.length;año++){
            for(int edad=0;edad<viudasTemporalesCS[0].length;edad++){
                viudasTemporalesCS[año][edad] = fm.sumaProducto(derivadasInvalidosTemporalesCS[año], distViudas[edad]);
            }
        }

        //Obtenemos la cuenta individual de huerfanos
        for(int año=0;año<huerfanosTemporalesCS.length;año++){
            for(int edad=0;edad<huerfanosTemporalesCS[0].length;edad++){
                huerfanosTemporalesCS[año][edad] = fm.sumaProducto(derivadasInvalidosTemporalesCS[año], distHuerfanos[edad]);
            }
        }

        //Obtenemos la cuenta individual de ascendientes
        for(int año=0;año<ascendientesTemporalesCS.length;año++){
            for(int edad=0;edad<ascendientesTemporalesCS[0].length;edad++){
                ascendientesTemporalesCS[año][edad] = fm.sumaProducto(derivadasInvalidosTemporalesCS[año], distAscendientes[edad]);
            }
        }

        /********************************************************************
         * Obtenemos el vector final de cuenta individual de Cuota Social   *
         ********************************************************************/

        indexVec = 0;

        for(int año=anioProy;año<=anioProy+2;año++){
                (pension.equals("inv")?saldoCITempCS:pension.equals("ip100")?saldoCITempCSIP100:pension.equals("ipMenor100")?saldoCITempCSIPMenor100:saldoCITempCSIPMenor50)
                                            [(año<saldoCITempCS.length?año:saldoCITempCS.length-1)] +=
                                                             ((fm.sumaProducto(viudasTemporalesCS[indexVec], nvasViudas[indexVec]) * porcViuda) +
                                                             (fm.sumaProducto(huerfanosTemporalesCS[indexVec], nvosHuerf[indexVec]) * 0.2D) +
                                                             (fm.sumaProducto(ascendientesTemporalesCS[indexVec], nvasAsc[indexVec]) * 0.2D))/1000000D;
                indexVec++;
        }
        

        /********************************************************************************************
         * Obtenemos el saldo promedio en la subcuenta de Vivienda de los pensionados en cada año.  *
         ********************************************************************************************/
        saldoAcumVivPensionados = obtenerSaldoAcumuladoVivPensionados(asegBase,
                                                                      asegCotizan,
                                                                      saldoViv_L73,
                                                                      proySalReales,
                                                                      tasaBimestralVivienda[anioProy],
                                                                      capAporBimViv);


        //Obtenemos el vector de la CI de RCV de los pensionados temporales
        for(int edad=0;edad<saldoAcumVivPensionados.length;edad++){
            invalidosTempPromViv[edad] =  (fm.sumaVector(pensMitadAnio[edad])== 0?0:
                                          (fm.sumaProducto(pensMitadAnio[edad], saldoAcumVivPensionados[edad]))/fm.sumaVector(pensMitadAnio[edad]));
        }

        /***********************************************
         * OBTENEMOS MATRIZ DE PENSIONADOS TEMPORALES  *
         ***********************************************/

        //Para el primer año de proyección
        for(int edad=1;edad<=invalidosTempPromViv.length;edad++){
            invalidosTemporalesViv[0][edad] = invalidosTempPromViv[edad-1]*(Math.pow(1+tasaBimestralVivienda[(anioProy<tasaBimestralVivienda.length?anioProy:tasaBimestralVivienda.length-1)], 3));
        }

        //Para el segundo año de proyección
        for(int edad=1;edad<invalidosTemporalesViv[0].length;edad++){
            invalidosTemporalesViv[1][edad] = invalidosTemporalesViv[0][edad-1]*(1+tasaAnualViv[(anioProy+1<tasaAnualViv.length?anioProy+1:tasaAnualViv.length-1)]);
        }

        //Para el tercer año de proyección
        for(int edad=1;edad<invalidosTemporalesViv[0].length;edad++){
            invalidosTemporalesViv[2][edad] = invalidosTemporalesViv[1][edad]*(Math.pow(1+tasaBimestralVivienda[(anioProy+2<tasaBimestralVivienda.length?anioProy+2:tasaBimestralVivienda.length-1)], 3));
        }

        /*******************************************************************
         * Obtenemos a los pensionados temporales que pasan a definitivos. *
         *******************************************************************/

        (pension.equals("inv")?saldoCITempDefViv:pension.equals("ip100")?saldoCITempDefVivIP100:pension.equals("ipMenor100")?saldoCITempDefVivIPMenor100:saldoCITempDefVivIPMenor50)

                [(anioProy+2<saldoCITempDefViv.length?anioProy+2:saldoCITempDefViv.length-1)] =
                                    fm.sumaProducto(invalidosTemporalesViv[2], pensTempFinalAnio[3])/1000000D;

        /*************************************************************************
         * OBTENEMOS MATRIZ DE PENSIONES DERIVADAS DE LA MUERTE DE PENSIONADOS   *
         *************************************************************************/
        //Para el primer año
        for(int edad=0;edad<invalidosTempPromViv.length;edad++){
            derivadasInvalidosTemporalesViv[0][edad] = invalidosTempPromViv[edad] *
                                                       (Math.pow(1+(Math.pow(1+tasaAnualViv[(anioProy<tasaAnualViv.length?anioProy:tasaAnualViv.length-1)], 1D/12D)-1), 3));
        }

        //Para el segundo año de pryección
        for(int edad=0;edad<invalidosTemporalesViv[0].length;edad++){
            derivadasInvalidosTemporalesViv[1][edad] = invalidosTemporalesViv[0][edad] *
                                                       (Math.pow(1+ tasaBimestralVivienda[(anioProy+1<tasaBimestralVivienda.length?anioProy+1:tasaBimestralVivienda.length-1)], 3D));
        }

        //Para el tercer año de proyección
        for(int edad=0;edad<invalidosTemporalesViv[0].length;edad++){
            derivadasInvalidosTemporalesViv[2][edad] = invalidosTemporalesViv[1][edad] *
                                                       (Math.pow(1+(Math.pow(1+tasaAnualViv[(anioProy+2<tasaAnualViv.length?anioProy+2:tasaAnualViv.length-1)], 1D/12D)-1D), 3D));
        }

        /*****************************************************
         * OBTENEMOS MATRIZ DE PENSIONES DERIVADAS FINALES   *
         *****************************************************/

        //Obtenemos la cuenta individual de viudas
        for(int año=0;año<viudasTemporalesViv.length;año++){
            for(int edad=0;edad<viudasTemporalesViv[0].length;edad++){
                viudasTemporalesViv[año][edad] = fm.sumaProducto(derivadasInvalidosTemporalesViv[año], distViudas[edad]);
            }
        }

        //Obtenemos la cuenta individual de huerfanos
        for(int año=0;año<huerfanosTemporalesViv.length;año++){
            for(int edad=0;edad<huerfanosTemporalesViv[0].length;edad++){
                huerfanosTemporalesViv[año][edad] = fm.sumaProducto(derivadasInvalidosTemporalesViv[año], distHuerfanos[edad]);
            }
        }

        //Obtenemos la cuenta individual de ascendientes
        for(int año=0;año<ascendientesTemporalesViv.length;año++){
            for(int edad=0;edad<ascendientesTemporalesViv[0].length;edad++){
                ascendientesTemporalesViv[año][edad] = fm.sumaProducto(derivadasInvalidosTemporalesViv[año], distAscendientes[edad]);
            }
        }

        /****************************************************************
         * Obtenemos el vector final de cuenta individual de Vivienda   *
         ****************************************************************/

        indexVec = 0;

        for(int año=anioProy;año<=anioProy+2;año++){
                (pension.equals("inv")?saldoCITempViv:pension.equals("ip100")?saldoCITempVivIP100:pension.equals("ipMenor100")?saldoCITempVivIPMenor100:saldoCITempVivIPMenor50)
                                                [(año<saldoCITempViv.length?año:saldoCITempViv.length-1)] +=
                                                             ((fm.sumaProducto(viudasTemporalesViv[indexVec], nvasViudas[indexVec]) * porcViuda) +
                                                             (fm.sumaProducto(huerfanosTemporalesViv[indexVec], nvosHuerf[indexVec]) * 0.2D) +
                                                             (fm.sumaProducto(ascendientesTemporalesViv[indexVec], nvasAsc[indexVec]) * 0.2D))/1000000D;
                indexVec++;
        }

    }



    public double[][] obtenerSaldoAcumuladoVivPensionados(double[][] asegBase,
                                                          double[][] asegCotizan,
                                                          double[][] saldoSubcta,
                                                          double[]   salarioReales,
                                                          double     tasaBimViv,
                                                          double     capitAportBim){

        double[][] saldoAcum = new double[saldoSubcta.length][saldoSubcta[0].length];

        for(int edad=0;edad<saldoAcum.length;edad++){
            for(int ant=0;ant<saldoAcum[0].length;ant++){
                saldoAcum[edad][ant] = (asegBase[edad][ant]== 0?0:
                                       (saldoSubcta[edad][ant]* Math.pow(1D+tasaBimViv,3D)) +
                                       (salarioReales[edad] * asegCotizan[edad][ant+1] / asegBase[edad][ant]* Constantes.APORTACION_VIVIENDA *
                                        Constantes.ASEG_APORTAN_SIN_CREDITO * (Constantes.DIAS_ANUAL/6D) * capitAportBim ));

            }
        }
        return saldoAcum;
    }





    public double[][] obtenerSaldoAcumuladoRCVyCSPensionados(double[][] asegBase,
                                                             double[][] asegCotizan,
                                                             double[][] saldoSubcta,
                                                             double[]   salarioReales,
                                                             double     tasaBimRCVyCS,
                                                             double     comisionSobSaldo,
                                                             double     capitAportBim,
                                                             boolean    esRCV){

        double[][] saldoAcum = new double[saldoSubcta.length][saldoSubcta[0].length];

        for(int edad=0;edad<saldoAcum.length;edad++){
            for(int ant=0;ant<saldoAcum[0].length;ant++){
                saldoAcum[edad][ant] = (asegBase[edad][ant]== 0?0:
                                       (saldoSubcta[edad][ant]* Math.pow(1D+tasaBimRCVyCS,3D) * (1D-comisionSobSaldo/2D)) +
                                       (salarioReales[edad] * asegCotizan[edad][ant+1] / asegBase[edad][ant]* (esRCV ? Constantes.APORTACION_RCV : 1) * (Constantes.DIAS_ANUAL/6D) * capitAportBim * (1D-comisionSobSaldo/2D)));

            }
        }
        return saldoAcum;
    }


    public void obtenerSalariosProyeccionCuotaSocial(double[][] proySalReales,
                                             double[] rangoSalCS,
                                             double[] salMinReal){

        double[][] proyCuotaSocial = new double[proySalReales.length][proySalReales[0].length];

        for(int año=0;año<proyCuotaSocial.length;año++){
            for(int edad=0;edad<proyCuotaSocial[0].length;edad++){
                proyCuotaSocial[año][edad]=(proySalReales[año][edad]/salMinReal[año]<=1?rangoSalCS[0]:
                                            proySalReales[año][edad]/salMinReal[año]<=4?rangoSalCS[1]:
                                            proySalReales[año][edad]/salMinReal[año]<=7?rangoSalCS[2]:
                                            proySalReales[año][edad]/salMinReal[año]<=10?rangoSalCS[3]:
                                            proySalReales[año][edad]/salMinReal[año]<=15?rangoSalCS[4]:rangoSalCS[5]);
            }
        }
        this.salariosCSproy = proyCuotaSocial;

    }


    public double[][] obtenerSaldosRCVyCuotaSocial(double[][] asegVigentes,
                                                   double[][] asegCotizan,
                                                   double[][] asegNoCotizan,
                                                   double[][] saldoSubCtaL73,
                                                   double[][] probSobAseg,
                                                   double[]   proySalarios,
                                                   double     tasaBimestraRCVyCS,
                                                   double     comisionSobSaldo,
                                                   boolean    subCtaInd){//true para RCV
        
        double[][] proyRCVyCS = new double[saldoSubCtaL73.length][saldoSubCtaL73[0].length];
        
        //Para antiguedad 0
        for(int edad=1;edad<proyRCVyCS[0].length;edad++){
            proyRCVyCS[edad][0] = (asegVigentes[edad][0]==0?0: ((asegNoCotizan[edad][0]*saldoSubCtaL73[edad][0]*probSobAseg[0][edad-1])/asegVigentes[edad][0])*
                                Math.pow((1D+tasaBimestraRCVyCS),6D)*(1D-comisionSobSaldo));
        }
        //Para las demas antiguedades
        for(int edad=1;edad<proyRCVyCS.length;edad++){
            for(int ant=1;ant<proyRCVyCS[0].length;ant++){
                proyRCVyCS[edad][ant] = (asegVigentes[edad][ant]==0?0:
                                     ((((asegCotizan[edad-1][ant]*saldoSubCtaL73[edad-1][ant-1]+asegNoCotizan[edad-1][ant]*saldoSubCtaL73[edad-1][ant])*probSobAseg[(ant<=2?0:ant<=9?1:2)][edad-1])/asegVigentes[edad][ant]) *
                                     Math.pow((1D+tasaBimestraRCVyCS),6D) + ((proySalarios[edad] * (subCtaInd ? Constantes.APORTACION_RCV:1) * Constantes.DIAS_ANUAL * asegCotizan[edad-1][ant] * probSobAseg[(ant<=2?0:ant<=9?1:2)][edad-1]) /
                                     (6D*asegVigentes[edad][ant])) * (((Math.pow((1D+tasaBimestraRCVyCS),5)-1D) / tasaBimestraRCVyCS) * Math.pow((1D+tasaBimestraRCVyCS),0.5D) + 1D)) * (1D-comisionSobSaldo) );
            }
        }
        return proyRCVyCS;
    }


    public double[][] obtenerSaldoVivienda(double[][] asegVigentes,
                                           double[][] asegCotizan,
                                           double[][] asegNoCotizan,
                                           double[][] saldoSubCtaVivL73,
                                           double[][] probSobAseg,
                                           double[]   proySalarios,
                                           double     tasaBimestralVivienda){

        double[][] proyVivienda = new double[saldoSubCtaVivL73.length][saldoSubCtaVivL73[0].length];

        //Para antiguedad 0
        for(int edad=1;edad<proyVivienda[0].length;edad++){
            proyVivienda[edad][0] = (asegVigentes[edad][0]==0?0: ((asegNoCotizan[edad][0]*saldoSubCtaVivL73[edad][0]*probSobAseg[0][edad-1])/asegVigentes[edad][0])*
                                Math.pow((1D+tasaBimestralVivienda),6D));
        }
        //Para las demas antiguedades
        for(int edad=1;edad<proyVivienda.length;edad++){
            for(int ant=1;ant<proyVivienda[0].length;ant++){
                proyVivienda[edad][ant] = (asegVigentes[edad][ant]==0?0:
                                     ((((asegCotizan[edad-1][ant]*saldoSubCtaVivL73[edad-1][ant-1]+asegNoCotizan[edad-1][ant]*saldoSubCtaVivL73[edad-1][ant])*probSobAseg[(ant<=2?0:ant<=9?1:2)][edad-1])/asegVigentes[edad][ant]) *
                                     Math.pow((1D+tasaBimestralVivienda),6D) + ((proySalarios[edad] * Constantes.APORTACION_VIVIENDA*Constantes.ASEG_APORTAN_SIN_CREDITO * Constantes.DIAS_ANUAL * asegCotizan[edad-1][ant] * probSobAseg[(ant<=2?0:ant<=9?1:2)][edad-1]) /
                                     (6D*asegVigentes[edad][ant])) * (((Math.pow((1D+tasaBimestralVivienda),5D)-1D) / tasaBimestralVivienda) * Math.pow((1D+tasaBimestralVivienda),0.5D) + 1D)));
            }
        }
        return proyVivienda;
    }




    public double[][] getRcvProyectada() {
        return rcvProyectada;
    }

    public double[][] getCsProyectada() {
        return csProyectada;
    }

    public double[][] getSalariosCSproy() {
        return salariosCSproy;
    }

    public double[][] getVivProyectada() {
        return vivProyectada;
    }

    public double[] getSaldoPromRCVPensionados() {
        return saldoPromRCVPensionados;
    }

    public double[] getSaldoPromCSPensionados() {
        return saldoPromCSPensionados;
    }

    public double[] getSaldoPromVivPensionados() {
        return saldoPromVivPensionados;
    }

    public double[] getSaldoCITempRCV() {
        return saldoCITempRCV;
    }

    public double[] getSaldoCITempCS() {
        return saldoCITempCS;
    }

    public double[] getSaldoCITempDefCS() {
        return saldoCITempDefCS;
    }

    public double[] getSaldoCITempDefRCV() {
        return saldoCITempDefRCV;
    }

    public double[] getSaldoCITempDefViv() {
        return saldoCITempDefViv;
    }

    public double[] getSaldoCITempViv() {
        return saldoCITempViv;
    }

    public double[] getSaldoCITempCSIP100() {
        return saldoCITempCSIP100;
    }

    public double[] getSaldoCITempCSIPMenor100() {
        return saldoCITempCSIPMenor100;
    }

    public double[] getSaldoCITempCSIPMenor50() {
        return saldoCITempCSIPMenor50;
    }

    public double[] getSaldoCITempRCVIP100() {
        return saldoCITempRCVIP100;
    }

    public double[] getSaldoCITempRCVIPMenor100() {
        return saldoCITempRCVIPMenor100;
    }

    public double[] getSaldoCITempRCVIPMenor50() {
        return saldoCITempRCVIPMenor50;
    }

    public double[] getSaldoCITempVivIP100() {
        return saldoCITempVivIP100;
    }

    public double[] getSaldoCITempVivIPMenor100() {
        return saldoCITempVivIPMenor100;
    }

    public double[] getSaldoCITempVivIPMenor50() {
        return saldoCITempVivIPMenor50;
    }

    public double[] getSaldoCITempDefCSIP100() {
        return saldoCITempDefCSIP100;
    }

    public double[] getSaldoCITempDefCSIPMenor100() {
        return saldoCITempDefCSIPMenor100;
    }

    public double[] getSaldoCITempDefCSIPMenor50() {
        return saldoCITempDefCSIPMenor50;
    }

    public double[] getSaldoCITempDefRCVIP100() {
        return saldoCITempDefRCVIP100;
    }

    public double[] getSaldoCITempDefRCVIPMenor100() {
        return saldoCITempDefRCVIPMenor100;
    }

    public double[] getSaldoCITempDefRCVIPMenor50() {
        return saldoCITempDefRCVIPMenor50;
    }

    public double[] getSaldoCITempDefVivIP100() {
        return saldoCITempDefVivIP100;
    }

    public double[] getSaldoCITempDefVivIPMenor100() {
        return saldoCITempDefVivIPMenor100;
    }

    public double[] getSaldoCITempDefVivIPMenor50() {
        return saldoCITempDefVivIPMenor50;
    }

    

    

    

    

    

    

    

    

    

    

    



}
