/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ProyeccionPensionados;
import Librerias.FuncionesMatematicas;

/**
 *
 * @author Antonio-Alcalde
 */

public class ProyeccionFinanciera {

    private double[][] salarioNominal;
    private double[][] salarioPromedio;
    private double[][] proySalariosReales;
    private double[] salMinDiarioNominal;
    private double[] inflacionAnualAcumulada;
    private double[] cuantiaPromPensionados;
    private double[] cuantiaPromViudas;
    private double[] ctiaPromViudasDecimoCuarto;
    private double[] salariosReales;
    private double[] cuantiaPromHuerfyAsc;

    //NuevasVariables
    private double[] volumenPensionTitularesInv = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionViudasInv = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosInv = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesInv = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] volumenPensionTitularesCeve = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionViudasCeve = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosCeve = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesCeve = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] volumenPensionViudasMte = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosMte = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesMte = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] volumenPensionTitularesIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionViudasIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesIP100 = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] volumenPensionTitularesIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionViudasIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] volumenPensionTitularesIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionViudasIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] volumenPensionViudasMteRT = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosMteRT = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesMteRT = new double[Constantes.ANIOS_PROYECCION-1];

    //Temporales
    private double[] VolumenPensTemDefFinalAnio = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionViudasInvTemp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosInvTemp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesInvTemp = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] VolumenPensTemDefFinalAnioIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionViudasTempIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosTempIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesTempIP100 = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] VolumenPensTemDefFinalAnioIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionViudasTempIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosTempIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesTempIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] VolumenPensTemDefFinalAnioIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionViudasTempIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionHuerfanosTempIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] volumenPensionAscendientesTempIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];

    private double volPenFinAnio;
    private double volPenTempSobaniocompleto;
    private double volPensTemDefMitadAnio;
    private double VolPensTemDefFinalAnio;

    
    

    
    

    public void obtenerVolumenPensionesTitulares(double[][] penFinalAnio,
                                                 double[][] penFallecidos,
                                                 double[]   ctiaPromPenMitadAnio,
                                                 int        anioProy,
                                                 String     pension,
                                                 String     seguro){

        double[][] proyCtiaPromTitularesFinalAnio = new double[penFinalAnio.length][penFinalAnio[0].length];
        //double[] proyCtiaPromMitadAnio = new double[ctiaPromPenMitadAnio.length];

        //Creamos los objetos que se utilizarán.
        FuncionesMatematicas fm = new FuncionesMatematicas();
        
        /***********************************************************************
         * Proyeccion de la cuantia promedio de pensionados al final de año.   *
         ***********************************************************************/
        //Para el primer año de proyeccion.
        if(seguro.equals("IV")){
                for(int edad=1;edad<=ctiaPromPenMitadAnio.length;edad++){
                    proyCtiaPromTitularesFinalAnio[0][edad]=(edad<45?ctiaPromPenMitadAnio[edad-1]:ctiaPromPenMitadAnio[edad-1]*Constantes.DECIMO_CUARTO);

                }
        }else{
                for(int edad=1;edad<=ctiaPromPenMitadAnio.length;edad++){
                    proyCtiaPromTitularesFinalAnio[0][edad]=(edad==45?ctiaPromPenMitadAnio[edad-1]*Constantes.DECIMO_CUARTO:ctiaPromPenMitadAnio[edad-1]);
            }
        }
            
        

        //Para los demas años de proyeccion.
        for(int año=1;año<penFinalAnio.length;año++){
            for(int edad=2;edad<penFinalAnio[0].length;edad++){
                proyCtiaPromTitularesFinalAnio[año][edad]=(edad ==45?proyCtiaPromTitularesFinalAnio[año-1][edad-1]*Constantes.DECIMO_CUARTO:proyCtiaPromTitularesFinalAnio[año-1][edad-1]);

            }
        }

        /*****************************************
         * Obtención del volumen de pensiones.   *
         *****************************************/
        if(seguro.equals("IV")){

            (pension.equals("ceve")?volumenPensionTitularesCeve:volumenPensionTitularesInv)[anioProy]+=
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[0], penFinalAnio[0])/1000000D)/2D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[0], penFallecidos[0])/1000000D)/4D;

             for(int año=1;año<proyCtiaPromTitularesFinalAnio.length-anioProy;año++){
                 (pension.equals("ceve")?volumenPensionTitularesCeve:volumenPensionTitularesInv)[año+anioProy]+=
                                                     fm.sumaProducto(proyCtiaPromTitularesFinalAnio[año], penFinalAnio[año])/1000000D +
                                                    (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[año], penFallecidos[año])/1000000D)/2D;
              }

        }else{
            (pension.equals("ip100")?volumenPensionTitularesIP100:pension.equals("ipMenor100")?volumenPensionTitularesIPMenor100:volumenPensionTitularesIPMenor50)[anioProy]+=
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[0], penFinalAnio[0])/1000000D)/2D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[0], penFallecidos[0])/1000000D)/4D;

             for(int año=1;año<proyCtiaPromTitularesFinalAnio.length-anioProy;año++){
                 (pension.equals("ip100")?volumenPensionTitularesIP100:pension.equals("ipMenor100")?volumenPensionTitularesIPMenor100:volumenPensionTitularesIPMenor50)[año+anioProy]+=
                                                     fm.sumaProducto(proyCtiaPromTitularesFinalAnio[año], penFinalAnio[año])/1000000D +
                                                    (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[año], penFallecidos[año])/1000000D)/2D;
              }

        }

         

    }

    public void obtenerVolumenPensionesTitularesTemporales(double[][] penFinalAnio,
                                                           double[][] penFallecidos,
                                                           double[]   ctiaPromPenMitadAnio,
                                                           int        anioProy,
                                                           String     pension,
                                                           String     seguro){

        //La longitud de la matriz es de Constantes.ANIOS_PROYECCION ya que es 1 año mas q las defintivas
        double[][] proyCtiaPromTitularesFinalAnio = new double[penFinalAnio.length][penFinalAnio[0].length];

        //Creamos los objetos que se utilizarán.
        FuncionesMatematicas fm = new FuncionesMatematicas();

        /***********************************************************************
         * Proyeccion de la cuantia promedio de pensionados al final de año.   *
         ***********************************************************************/

        if(seguro.equals("IV")){

            //Para el primer año de proyeccion.
            for(int edad=1;edad<=ctiaPromPenMitadAnio.length;edad++){
                        proyCtiaPromTitularesFinalAnio[0][edad]=(edad<45?ctiaPromPenMitadAnio[edad-1]:ctiaPromPenMitadAnio[edad-1]*Constantes.DECIMO_CUARTO);
            }

            //Para el segundo año
            for(int edad=2;edad<proyCtiaPromTitularesFinalAnio[0].length;edad++){
                    proyCtiaPromTitularesFinalAnio[1][edad]=(edad == 45?proyCtiaPromTitularesFinalAnio[0][edad-1]*Constantes.DECIMO_CUARTO:proyCtiaPromTitularesFinalAnio[0][edad-1]);

            }

            //Para el tercer año
            proyCtiaPromTitularesFinalAnio[2] = proyCtiaPromTitularesFinalAnio[1];

            //Para los demas años de proyeccion.
            for(int año=3;año<proyCtiaPromTitularesFinalAnio.length;año++){
                for(int edad=2;edad<proyCtiaPromTitularesFinalAnio[0].length;edad++){
                    proyCtiaPromTitularesFinalAnio[año][edad]=(edad ==45?proyCtiaPromTitularesFinalAnio[año-1][edad-1]*Constantes.DECIMO_CUARTO:proyCtiaPromTitularesFinalAnio[año-1][edad-1]);

                }
            }

        }else{

            //Para el primer año de proyeccion.
            for(int edad=1;edad<=ctiaPromPenMitadAnio.length;edad++){
                        proyCtiaPromTitularesFinalAnio[0][edad]=(edad==45?ctiaPromPenMitadAnio[edad-1]*Constantes.DECIMO_CUARTO:ctiaPromPenMitadAnio[edad-1]);
            }

            //Para el segundo año
            for(int edad=2;edad<proyCtiaPromTitularesFinalAnio[0].length;edad++){
                    proyCtiaPromTitularesFinalAnio[1][edad]=(edad == 45?proyCtiaPromTitularesFinalAnio[0][edad-1]*Constantes.DECIMO_CUARTO:proyCtiaPromTitularesFinalAnio[0][edad-1]);

            }

            //Para el tercer año
            proyCtiaPromTitularesFinalAnio[2] = proyCtiaPromTitularesFinalAnio[1];

            //Para los demas años de proyeccion.
            for(int año=3;año<proyCtiaPromTitularesFinalAnio.length;año++){
                for(int edad=2;edad<proyCtiaPromTitularesFinalAnio[0].length;edad++){
                    proyCtiaPromTitularesFinalAnio[año][edad]=(edad ==45?proyCtiaPromTitularesFinalAnio[año-1][edad-1]*Constantes.DECIMO_CUARTO:proyCtiaPromTitularesFinalAnio[año-1][edad-1]);

                }
            }

        }        
        /*****************************************
         * Obtención del volumen de pensiones.   *
         *****************************************/
        if(seguro.equals("IV")){

            //Para el primer año
            volPenFinAnio = (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[0], penFinalAnio[0])/1000000D)/2D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[0], penFallecidos[0])/1000000D)/4D;            

            //Para el segundo año             
            volPenTempSobaniocompleto = fm.sumaProducto(proyCtiaPromTitularesFinalAnio[1], penFinalAnio[1])/1000000D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[1], penFallecidos[1])/1000000D)/2D;

            //Para el tercer año
            volPensTemDefMitadAnio = (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[2], penFinalAnio[2])/1000000D)/2D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[2], penFallecidos[2])/1000000D)/4D;

            //Para el cuarto año
            VolPensTemDefFinalAnio= (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[3], penFinalAnio[3])/1000000D)/2D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[3], penFallecidos[3])/1000000D)/4D;

            //Para los demas años
            for(int año=4;año<VolumenPensTemDefFinalAnio.length-anioProy;año++){
                VolumenPensTemDefFinalAnio[año+anioProy]+=
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[año], penFinalAnio[año])/1000000D) +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[año], penFallecidos[año])/1000000D)/2D;
            }
            

        }else{

            //Para el primer año
            volPenFinAnio = (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[0], penFinalAnio[0])/1000000D)/2D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[0], penFallecidos[0])/1000000D)/4D;

            //Para el segundo año
            volPenTempSobaniocompleto = fm.sumaProducto(proyCtiaPromTitularesFinalAnio[1], penFinalAnio[1])/1000000D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[1], penFallecidos[1])/1000000D)/2D;

            //Para el tercer año
            volPensTemDefMitadAnio = (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[2], penFinalAnio[2])/1000000D)/2D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[2], penFallecidos[2])/1000000D)/4D;

            //Para el cuarto año
            VolPensTemDefFinalAnio = (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[3], penFinalAnio[3])/1000000D)/2D +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[3], penFallecidos[3])/1000000D)/4D;

            //Para los demas años
            for(int año=4;año<VolumenPensTemDefFinalAnioIP100.length-anioProy;año++){
                (pension.equals("ip100")?VolumenPensTemDefFinalAnioIP100:pension.equals("ipMenor100")?VolumenPensTemDefFinalAnioIPMenor100:VolumenPensTemDefFinalAnioIPMenor50)[año+anioProy]+=
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[año], penFinalAnio[año])/1000000D) +
                                            (fm.sumaProducto(proyCtiaPromTitularesFinalAnio[año], penFallecidos[año])/1000000D)/2D;
            }
        }



    }



    public void obtenerVolumenPensionesDerivadas(double[][] penFallecidos,
                                                 double[][] distDerivadas,
                                                 double[][] derivadasSobCadaAnio,
                                                 double[][] derivadasSobFinalAnio,
                                                 double[][] nuevasDerivadasFallecen,
                                                 double[][] derivadasFallecenCadaAnio,
                                                 double[][] probAct,
                                                 double[]   ctiaPromDerivadas,
                                                 int        anioProy,
                                                 char       derivada,
                                                 String     pension,
                                                 String     seguro){

        //Creamos los objetos que se utilizarán.
        FuncionesMatematicas fm = new FuncionesMatematicas();

        double[][] proyCtiaPromDerivadas = new double[penFallecidos.length][penFallecidos[0].length];
        double[][] proyCtiaPromNvasDerivadas = new double[penFallecidos.length][penFallecidos[0].length];
        double[][] proyCtiaPromDerivadasSobCadaAnio = new double[penFallecidos.length][penFallecidos[0].length];


        /**********************************************************
         * Proyeccion de la cuantia promedio para las derivadas   *
         **********************************************************/

        //Para el primer año de proyeccion.
        if(seguro.equals("IV")){//Para el SIV
            for(int edad=0;edad<ctiaPromDerivadas.length;edad++){
                proyCtiaPromDerivadas[0][edad]= ctiaPromDerivadas[edad]*(derivada == 'v'? 1 :Constantes.DECIMO_CUARTO);
            }
        }else{
            for(int edad=0;edad<ctiaPromDerivadas.length;edad++){
                proyCtiaPromDerivadas[0][edad]= ctiaPromDerivadas[edad];
            }
        }        

        //Para los demas años
        for(int año=1;año<penFallecidos.length;año++){
            for(int edad=1;edad<penFallecidos[0].length;edad++){
                proyCtiaPromDerivadas[año][edad]=proyCtiaPromDerivadas[año-1][edad-1];
            }
        }      
        
        /**********************************************************************************
         * Proyeccion de la cuantia promedio de nuevas viudas en cada año de proyeccion   *
         **********************************************************************************/


        for (int año = 0; año < penFallecidos.length; año++) {
            for (int edad = 0; edad < penFallecidos[0].length; edad++) {
                proyCtiaPromNvasDerivadas[año][edad] = fm.sumaProducto(proyCtiaPromDerivadas[año], distDerivadas[edad]);
            }
        }
                       
        /******************************************************************************************
         * Proyeccion de la cuantia promedio de viudas sobrevivientes en cada año de proyeccion   *
         ******************************************************************************************/
        //Para el primer año de proyeccion
        proyCtiaPromDerivadasSobCadaAnio[0] = proyCtiaPromNvasDerivadas[0];

        //Para la primer antiguedad de cada uno de los año
        for(int año=0;año<proyCtiaPromDerivadasSobCadaAnio.length;año++){
            proyCtiaPromDerivadasSobCadaAnio[año][0] = proyCtiaPromNvasDerivadas[año][0];
        }


        //Para los demas año de proyeccion
        for (int año = 1; año < proyCtiaPromDerivadasSobCadaAnio.length; año++) {
            for (int edad = 1; edad < proyCtiaPromDerivadasSobCadaAnio[0].length; edad++) {
                proyCtiaPromDerivadasSobCadaAnio[año][edad]= (derivadasSobCadaAnio[año-1][edad-1] * (derivada=='v' || derivada=='a'? 1- probAct[año][edad+14]:probAct[año][edad-1])+ derivadasSobFinalAnio[año][edad]==0 ? 0:
                                                          (derivadasSobCadaAnio[año-1][edad-1] * (derivada=='v' || derivada=='a'? 1- probAct[año][edad+14]:probAct[año][edad-1]) * proyCtiaPromDerivadasSobCadaAnio[año-1][edad-1] +
                                                           derivadasSobFinalAnio[año][edad]*proyCtiaPromNvasDerivadas[año][edad]) /
                                                           (double)(derivadasSobCadaAnio[año-1][edad-1] * (derivada=='v' || derivada=='a'? 1- probAct[año][edad+14]:probAct[año][edad-1]) + derivadasSobFinalAnio[año][edad]));

            }
        }  
        
        /*****************************************
         * Obtencion del volumen de pensiones.   *
         *****************************************/

        if(seguro.equals("IV")){

            if (pension.equals("inv")) {//Invalidez

            (derivada == 'v' ? volumenPensionViudasInv : derivada == 'h' ? volumenPensionHuerfanosInv : volumenPensionAscendientesInv)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 4D
                    + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 8D) / 1000000D);

            for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                (derivada == 'v' ? volumenPensionViudasInv : derivada == 'h' ? volumenPensionHuerfanosInv : volumenPensionAscendientesInv)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);
            }

            }else if (pension.equals("ceve")){//Cesantía en edad avanzada y vejez

            (derivada == 'v' ? volumenPensionViudasCeve : derivada == 'h' ? volumenPensionHuerfanosCeve : volumenPensionAscendientesCeve)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 4D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 8D) / 1000000D);

            for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                (derivada == 'v' ? volumenPensionViudasCeve : derivada == 'h' ? volumenPensionHuerfanosCeve : volumenPensionAscendientesCeve)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);
            }

            }else{//Muerte por enfermedad general

            (derivada == 'v' ? volumenPensionViudasMte : derivada == 'h' ? volumenPensionHuerfanosMte : volumenPensionAscendientesMte)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 2D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 4D) / 1000000D);

            for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                (derivada == 'v' ? volumenPensionViudasMte : derivada == 'h' ? volumenPensionHuerfanosMte : volumenPensionAscendientesMte)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);
            }

          }

        }else{//Para el SRT

            if (pension.equals("ip100")) {//Incapacidad igual al 100

                (derivada == 'v' ? volumenPensionViudasIP100 : derivada == 'h' ? volumenPensionHuerfanosIP100 : volumenPensionAscendientesIP100)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 4D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 8D) / 1000000D);

                    for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                        (derivada == 'v' ? volumenPensionViudasIP100 : derivada == 'h' ? volumenPensionHuerfanosIP100 : volumenPensionAscendientesIP100)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);
                    }
            }else if(pension.equals("ipMenor100")){

                (derivada == 'v' ? volumenPensionViudasIPMenor100 : derivada == 'h' ? volumenPensionHuerfanosIPMenor100 : volumenPensionAscendientesIPMenor100)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 4D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 8D) / 1000000D);                

                    for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                        (derivada == 'v' ? volumenPensionViudasIPMenor100 : derivada == 'h' ? volumenPensionHuerfanosIPMenor100 : volumenPensionAscendientesIPMenor100)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D); 
                        
                    }

            } else if(pension.equals("ipMenor50")){

                (derivada == 'v' ? volumenPensionViudasIPMenor50 : derivada == 'h' ? volumenPensionHuerfanosIPMenor50 : volumenPensionAscendientesIPMenor50)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 4D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 8D) / 1000000D);

                    for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                        (derivada == 'v' ? volumenPensionViudasIPMenor50 : derivada == 'h' ? volumenPensionHuerfanosIPMenor50 : volumenPensionAscendientesIPMenor50)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);
                    }
            }
            else{

                (derivada == 'v' ? volumenPensionViudasMteRT : derivada == 'h' ? volumenPensionHuerfanosMteRT : volumenPensionAscendientesMteRT)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 2D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 4D) / 1000000D);

                    for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                        (derivada == 'v' ? volumenPensionViudasMteRT : derivada == 'h' ? volumenPensionHuerfanosMteRT : volumenPensionAscendientesMteRT)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                                + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);
                    }


            }

        }

        
        
        
     
}

    public void obtenerVolumenPensionesDerivadasTemp(double[][] penFallecidos,
                                                     double[][] distDerivadas,
                                                     double[][] derivadasSobCadaAnio,
                                                     double[][] derivadasSobFinalAnio,
                                                     double[][] nuevasDerivadasFallecen,
                                                     double[][] derivadasFallecenCadaAnio,
                                                     double[][] probAct,
                                                     double[]   ctiaPromDerivadas,
                                                     int        anioProy,
                                                     char       derivada,
                                                     String     pension,
                                                     String     seguro){




        //Creamos los objetos que se utilizarán.
        FuncionesMatematicas fm = new FuncionesMatematicas();

        double[][] proyCtiaPromDerivadas = new double[penFallecidos.length][penFallecidos[0].length];
        double[][] proyCtiaPromNvasDerivadas = new double[penFallecidos.length][penFallecidos[0].length];
        double[][] proyCtiaPromDerivadasSobCadaAnio = new double[penFallecidos.length][penFallecidos[0].length];


        /**********************************************************
         * Proyeccion de la cuantia promedio para las derivadas   *
         **********************************************************/

        //Para el primer año de proyeccion.
        if(seguro.equals("IV")){//Para el SIV
            for(int edad=0;edad<ctiaPromDerivadas.length;edad++){
                proyCtiaPromDerivadas[0][edad]= ctiaPromDerivadas[edad]*(derivada == 'v'? 1 :Constantes.DECIMO_CUARTO);
            }
        }else{
            for(int edad=0;edad<ctiaPromDerivadas.length;edad++){
                proyCtiaPromDerivadas[0][edad]= ctiaPromDerivadas[edad];
            }
        }

        //Para los demas años
        for(int año=1;año<penFallecidos.length-1;año++){
            for(int edad=1;edad<penFallecidos[0].length;edad++){
                proyCtiaPromDerivadas[año][edad]=proyCtiaPromDerivadas[año-1][edad-1];
            }
        }

        /**********************************************************************************
         * Proyeccion de la cuantia promedio de nuevas viudas en cada año de proyeccion   *
         **********************************************************************************/


        for (int año = 0; año < penFallecidos.length-1; año++) {
            for (int edad = 0; edad < penFallecidos[0].length; edad++) {
                proyCtiaPromNvasDerivadas[año][edad] = fm.sumaProducto(proyCtiaPromDerivadas[año], distDerivadas[edad]);
            }
        }

        /******************************************************************************************
         * Proyeccion de la cuantia promedio de viudas sobrevivientes en cada año de proyeccion   *
         ******************************************************************************************/
        //Para el primer año de proyeccion
        proyCtiaPromDerivadasSobCadaAnio[0] = proyCtiaPromNvasDerivadas[0];

        //Para la primer antiguedad de cada uno de los año
        for(int año=0;año<proyCtiaPromDerivadasSobCadaAnio.length;año++){
            proyCtiaPromDerivadasSobCadaAnio[año][0] = proyCtiaPromNvasDerivadas[año][0];
        }


        //Para los demas año de proyeccion
        for (int año = 1; año < proyCtiaPromDerivadasSobCadaAnio.length; año++) {
            for (int edad = 1; edad < proyCtiaPromDerivadasSobCadaAnio[0].length; edad++) {
                proyCtiaPromDerivadasSobCadaAnio[año][edad]= (derivadasSobCadaAnio[año-1][edad-1] * (derivada=='v' || derivada=='a'? 1- probAct[año][edad+14]:probAct[año][edad-1])+ derivadasSobFinalAnio[año][edad]==0 ? 0:
                                                          (derivadasSobCadaAnio[año-1][edad-1] * (derivada=='v' || derivada=='a'? 1- probAct[año][edad+14]:probAct[año][edad-1]) * proyCtiaPromDerivadasSobCadaAnio[año-1][edad-1] +
                                                           derivadasSobFinalAnio[año][edad]*proyCtiaPromNvasDerivadas[año][edad]) /
                                                           (double)(derivadasSobCadaAnio[año-1][edad-1] * (derivada=='v' || derivada=='a'? 1- probAct[año][edad+14]:probAct[año][edad-1]) + derivadasSobFinalAnio[año][edad]));

            }
        }
        

        /*****************************************
         * Obtencion del volumen de pensiones.   *
         *****************************************/

        if(seguro.equals("IV")){

            //Invalidez
            (derivada == 'v' ? volumenPensionViudasInvTemp : derivada == 'h' ? volumenPensionHuerfanosInvTemp : volumenPensionAscendientesInvTemp)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 4D
                    + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 8D) / 1000000D);

            for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                (derivada == 'v' ? volumenPensionViudasInvTemp : derivada == 'h' ? volumenPensionHuerfanosInvTemp : volumenPensionAscendientesInvTemp)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                        + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);                                
            }
        
        }else{//Para el SRT

            if (pension.equals("ip100")) {//Incapacidad igual al 100

                (derivada == 'v' ? volumenPensionViudasTempIP100 : derivada == 'h' ? volumenPensionHuerfanosTempIP100 : volumenPensionAscendientesTempIP100)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 4D
                    + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 8D) / 1000000D);

                for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                    (derivada == 'v' ? volumenPensionViudasTempIP100 : derivada == 'h' ? volumenPensionHuerfanosTempIP100 : volumenPensionAscendientesTempIP100)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                            + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                            + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                            + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);
                }
            }else if(pension.equals("ipMenor100")){

                (derivada == 'v' ? volumenPensionViudasTempIPMenor100 : derivada == 'h' ? volumenPensionHuerfanosTempIPMenor100 : volumenPensionAscendientesTempIPMenor100)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 4D
                    + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 8D) / 1000000D);

                for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                    (derivada == 'v' ? volumenPensionViudasTempIPMenor100 : derivada == 'h' ? volumenPensionHuerfanosTempIPMenor100 : volumenPensionAscendientesTempIPMenor100)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                            + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                            + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                            + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);
                }
                
            } else if(pension.equals("ipMenor50")){

                (derivada == 'v' ? volumenPensionViudasTempIPMenor50 : derivada == 'h' ? volumenPensionHuerfanosTempIPMenor50 : volumenPensionAscendientesTempIPMenor50)[anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], derivadasSobFinalAnio[0]) / 4D
                    + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[0], nuevasDerivadasFallecen[0]) / 8D) / 1000000D);

                for (int año = 1; año < penFallecidos.length - anioProy; año++) {
                    (derivada == 'v' ? volumenPensionViudasTempIPMenor50 : derivada == 'h' ? volumenPensionHuerfanosTempIPMenor50 : volumenPensionAscendientesTempIPMenor50)[año + anioProy] += ((fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobFinalAnio[año]) / 2D
                            + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasSobCadaAnio[año])
                            + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], nuevasDerivadasFallecen[año]) / 4D
                            + fm.sumaProducto(proyCtiaPromDerivadasSobCadaAnio[año], derivadasFallecenCadaAnio[año]) / 2D) / 1000000D);
                }
                
            }
            

        }





}
    public void obtenerCuantias(double[][] art167LSS,
                                double[][] penMitadAnio,
                                double[]   salarioPromedio,
                                double[]   ultimoSalario,
                                double     salarioMinimo,
                                double     inflacionAnual,
                                double     salMinGDF,
                                double     porValoracion,
                                String     pension,
                                String     seguro){

        //Creamos objetos que contienen informacio demografica
        ProyeccionDemografica pd = new ProyeccionDemografica();
        FuncionesMatematicas fm = new FuncionesMatematicas();

        double[][] cuantiaPensionados = new double[51][salarioPromedio.length];
        double[][] cuantiaViudas = new double[51][salarioPromedio.length];
        double[][] cuantiaHuerfyAsc = new double[51][salarioPromedio.length];
        double[][] cuantiaViudasDecimoCuarto = new double[51][salarioPromedio.length];
        double[] SMGDF = new double[salarioPromedio.length];
        double[] cuantiaBasica = new double[salarioPromedio.length];
        double[] incremento = new double[salarioPromedio.length];
        double[] ctiaPromPensionados = new double[salarioPromedio.length];
        double[] ctiaPromRT = new double[salarioPromedio.length];
        double[] ctiaPromViudas = new double[salarioPromedio.length];
        double[] ctiaPromViudasDecimoCuarto = new double[salarioPromedio.length];
        double[] ctiaPromHuerfyAsc = new double[salarioPromedio.length];
        double vecesSalMinGDF;
        boolean aplicaRedAct;

        aplicaRedAct = (pension.equals("ceve")?true:false);

        
        //Obtenemos el Salario Minimo del Distrito Federal
        for(int edad=0;edad<SMGDF.length;edad++){
            SMGDF[edad] = Math.floor((salarioPromedio[edad]/salarioMinimo)*100)/100;
        }

        //Obtenemos la cuantia basica y el incremento
        for (int edad = 1; edad < cuantiaBasica.length; edad++) {
            int rango = 0;
            while (SMGDF[edad] > art167LSS[0][rango]) {
                rango++;
            }
            cuantiaBasica[edad] = art167LSS[1][rango] * salarioPromedio[edad] * 365;
            incremento[edad] = art167LSS[2][rango] * salarioPromedio[edad] * 365;
        }
        
        /*************************************************************************
         * Obtenemos las cuantias basicas para los pensionados y sus derivadas   *
         *************************************************************************/

        /***********************************
         * Cuantia basica de pensionados   *
         ***********************************/
        
        double bloque1=0;
        double bloque2=0;
        double bloque3=0;
        double porcentaje=0.75;
        
        for(int antiguedad=3;antiguedad<cuantiaPensionados.length;antiguedad++){
            for(int edad=1;edad<cuantiaPensionados[0].length;edad++){

                bloque1 = cuantiaBasica[edad] + incremento[edad] *(antiguedad<=10?0:antiguedad-10);
                bloque2 = salarioPromedio[edad]*365;
                bloque3 = ((bloque1*1.2) > bloque2 ?(bloque1 < bloque2 ?bloque2:bloque1): bloque1*1.2);

                cuantiaPensionados[antiguedad][edad] = (Math.max(bloque3, salarioMinimo*365) +
                                                       Math.max(bloque1*(1D/12D), salarioMinimo*(365D/12D)))/inflacionAnual;
                
            }
        }
        

        //Obtenemos el vector de la cuantia promedio de pensionados mitad año
            for(int edad=0;edad<cuantiaPensionados[0].length;edad++){
                ctiaPromPensionados[edad] = (fm.sumaVector(penMitadAnio[edad]) == 0 ? 0: fm.sumaProducto(penMitadAnio[edad], fm.transponer(cuantiaPensionados)[edad])
                                         / fm.sumaVector(penMitadAnio[edad]))*(aplicaRedAct?(edad>=45 && edad<=49?porcentaje:1):1);
            if(edad>=45 && edad<=49){
                    porcentaje+=0.05D;
                }
            }

        //Se obtiene la cuantia de RT, en caso de que se este calculando el SRT
        if(seguro.equals("RT")){

            for(int edad=0;edad<ultimoSalario.length;edad++){
                ctiaPromRT[edad]=ultimoSalario[edad]*Constantes.DIAS_ANUAL*Constantes.PORC_CUANTIA_RT;
                ctiaPromPensionados[edad] =(edad<45? Math.max(ctiaPromRT[edad]*(1D+15D/Constantes.DIAS_ANUAL), ctiaPromPensionados[edad])*porValoracion :
                                             (Math.max(ctiaPromRT[edad]*(1D+15D/Constantes.DIAS_ANUAL), ctiaPromPensionados[edad])*porValoracion)*Constantes.DECIMO_CUARTO);
            }           
        }

        this.cuantiaPromPensionados = ctiaPromPensionados;
        
        /*************************
         * Cuantia para viudas   *
         *************************/

        
        
        for (int antiguedad = 3; antiguedad < cuantiaViudas.length; antiguedad++) {
            for (int edad = 1; edad < cuantiaViudas[0].length; edad++) {

                bloque1 = cuantiaBasica[edad] + incremento[edad] * (antiguedad <= 10 ? 0 : antiguedad - 10);
                bloque2 = salarioPromedio[edad] * 365;
                bloque3 = ((bloque1 * 1.1) > bloque2 ? (bloque1 < bloque2 ? bloque2 : bloque1) : bloque1 * 1.1);

                cuantiaViudas[antiguedad][edad] = (Math.max(bloque3, salarioMinimo * 365)
                        + Math.max(bloque1 * (1D / 12D), salarioMinimo * (365D / 12D))) / inflacionAnual;

            }
        }

        porcentaje=0.75D;

        //Obtenemos el vector de la cuantia promedio de viudas
            for(int edad=0;edad<cuantiaPensionados[0].length;edad++){
                    ctiaPromViudas[edad] = (fm.sumaVector(penMitadAnio[edad]) == 0?0: fm.sumaProducto(penMitadAnio[edad], fm.transponer(cuantiaViudas)[edad])
                                            / fm.sumaVector(penMitadAnio[edad]))*(aplicaRedAct?(edad>=45 && edad<=49?porcentaje:1):1);
                if(edad>=45 && edad<=49){
                    porcentaje+=0.05D;
                }
            }
        
        this.cuantiaPromViudas = ctiaPromViudas;

        /***********************************************************
         * Cuantia para viudas con aplicacion del decimo cuarto.   *
         ***********************************************************/

        vecesSalMinGDF = salMinGDF * Constantes.VECES_SMGDF * (Constantes.DIAS_ANUAL + Constantes.AYUDAS);
        
        for(int antiguedad=3;antiguedad<cuantiaViudasDecimoCuarto.length;antiguedad++){
            for(int edad=1;edad<cuantiaViudasDecimoCuarto[0].length;edad++){
                cuantiaViudasDecimoCuarto[antiguedad][edad] = (cuantiaViudas[antiguedad][edad]*Constantes.PORC_CUANTIA_VIUDEZ <= vecesSalMinGDF ?
                                             cuantiaViudas[antiguedad][edad]*Constantes.PORC_CUANTIA_VIUDEZ*Constantes.DECIMO_CUARTO:
                                             cuantiaViudas[antiguedad][edad]*Constantes.PORC_CUANTIA_VIUDEZ);
            }
        }
        porcentaje = 0.75D;

        //Obtenemos el vector de la cuantia promedio de viudas con el decimo cuarto
            for(int edad=0;edad<cuantiaPensionados[0].length;edad++){
                ctiaPromViudasDecimoCuarto[edad] = (fm.sumaVector(penMitadAnio[edad]) == 0 ? 0: fm.sumaProducto(penMitadAnio[edad], fm.transponer(cuantiaViudasDecimoCuarto)[edad])
                                                / fm.sumaVector(penMitadAnio[edad]))*(aplicaRedAct?(edad>=45 && edad<=49?porcentaje:1):1);
                //System.out.println(ctiaPromViudasDecimoCuarto[edad]);
                if(edad>=45 && edad<=49){
                    porcentaje+=0.05D;
                }
            }

        double bloqueRT=0;

        //Se obtiene la cuantia de RT, en caso de que se este calculando el SRT
        if(seguro.equals("RT")){

            vecesSalMinGDF = salMinGDF * Constantes.VECES_SMGDF * (Constantes.DIAS_ANUAL + 15D);

            for(int edad=0;edad<ultimoSalario.length;edad++){
                bloqueRT=(ctiaPromRT[edad]*Constantes.PORC_CUANTIA_VIUDEZ_RT<=vecesSalMinGDF ?1D: Constantes.DECIMO_CUARTO)*ctiaPromRT[edad]*(1+Constantes.NUMERO_CTIA_RT)*Constantes.PORC_CUANTIA_VIUDEZ_RT;
                ctiaPromViudasDecimoCuarto[edad] = Math.max(bloqueRT, ctiaPromViudasDecimoCuarto[edad]);                

            }
        }
        this.ctiaPromViudasDecimoCuarto = ctiaPromViudasDecimoCuarto;

        /*******************************************
         * Cuantia para huerfanos y ascendientes   *
         *******************************************/

        for (int antiguedad = 3; antiguedad < cuantiaHuerfyAsc.length; antiguedad++) {
            for (int edad = 1; edad < cuantiaHuerfyAsc[0].length; edad++) {

                bloque1 = cuantiaBasica[edad] + incremento[edad] * (antiguedad <= 10 ? 0 : antiguedad - 10);
                bloque2 = salarioPromedio[edad] * Constantes.DIAS_ANUAL;
                bloque3 = (bloque1 > bloque2 ? (bloque1 < bloque2 ? bloque2 : bloque1) : bloque1);

                cuantiaHuerfyAsc[antiguedad][edad] = (Math.max(bloque3, salarioMinimo * Constantes.DIAS_ANUAL)
                        + Math.max(bloque1 * (1D / 12D), salarioMinimo * (Constantes.DIAS_ANUAL / 12D))) / inflacionAnual * Constantes.PORC_CUANTIA_HUERF_ASC;

            }
        }

        porcentaje = 0.75D;
        //Obtenemos el vector de la cuantia promedio de huerfanos y ascendientes
            for(int edad=0;edad<cuantiaPensionados[0].length;edad++){
                    ctiaPromHuerfyAsc[edad] = (fm.sumaVector(penMitadAnio[edad]) == 0?0: fm.sumaProducto(penMitadAnio[edad], fm.transponer(cuantiaHuerfyAsc)[edad])
                                               / fm.sumaVector(penMitadAnio[edad]))*(aplicaRedAct?(edad>=45 && edad<=49?porcentaje:1):1);
                if(edad>=45 && edad<=49){
                    porcentaje+=0.05D;
                }
            }
        
        //Se obtiene la cuantia de RT, en caso de que se este calculando el SRT
        if(seguro.equals("RT")){

            for(int edad=0;edad<ultimoSalario.length;edad++){                
                ctiaPromHuerfyAsc[edad] = Math.max(ctiaPromRT[edad]*Constantes.PORC_CUANTIA_HUERF_ASC*Constantes.DECIMO_CUARTO, ctiaPromHuerfyAsc[edad]*Constantes.DECIMO_CUARTO);

            }
        }

        this.cuantiaPromHuerfyAsc = ctiaPromHuerfyAsc;

    }

    public void obtenerSalarios(double[][] salHistoricos,
                                double[] incRealSalarios,
                                double[] incRealSalMinimo,
                                double[] inflacionAnual,
                                double[] salarioReal){

        double[][] salarioNominal = new double[salHistoricos.length+(Constantes.ANIOS_PROYECCION-1)][salHistoricos[0].length];
        double[][] salarioPromedio = new double[Constantes.ANIOS_PROYECCION-1][salHistoricos[0].length];
        double[][] proySalReales = new double[Constantes.ANIOS_PROYECCION-1][salarioReal.length];
        double[] salarioMinDiarioNominal = new double[incRealSalarios.length];
        double[] inflacionAnualAcumulada = new double[inflacionAnual.length];
        double[] salariosReales = new double[inflacionAnual.length];

        /*****************************************
         * Obtención de los salarios nominales.  *
         *****************************************/

        //Llenamos los primeros años de la matriz con los salarios historicos
        for (int i = 0; i < salHistoricos.length; i++) {
            salarioNominal[i] = salHistoricos[i];
        }

        //Proyectamos nuestro salario apartir del salario del año base.
        for(int año=10;año<salarioNominal.length;año++){//iniciamos en el año 20111, solo q antes traemos los historicos
            for(int edad=0;edad<salarioNominal[0].length;edad++){
                salarioNominal[año][edad]=salarioNominal[año-1][edad]*(1+incRealSalarios[año-10])*(1+inflacionAnual[año-10]);
            }
        }

        this.salarioNominal = salarioNominal;

        /*****************************************
         * Obtención de los salarios promedio.   *
         *****************************************/
        
        for (int año = 0; año < Constantes.ANIOS_PROYECCION - 1; año++) {//Año que se proyecta el salario promedio
            for (int edad = 1; edad < salHistoricos[0].length; edad++) {//Edad del asegurado
                if (edad <= 5) {
                    for (int edadHist = edad,añoHist=año+10; edadHist >= 0; edadHist--) {//Edades anteriores del asegurado
                        salarioPromedio[año][edad] += salarioNominal[añoHist][edadHist] * (edadHist == edad || edadHist == 0 ? 0.5 : 1);
                        if (edadHist == 0) {
                            salarioPromedio[año][edad] /= edad;
                        }
                        añoHist--;
                    }
                } else {
                    for (int edadHist = edad,añoHist=año+10; edadHist >= edad - 5; edadHist--) {//Edades anteriores del asegurado
                        salarioPromedio[año][edad] += salarioNominal[añoHist][edadHist] * (edadHist == edad || edadHist + 5 == edad ? 0.5 : 1);
                        if (edadHist + 5 == edad) {
                            salarioPromedio[año][edad] /= 5D;
                        }
                        añoHist--;
                    }

                }
            }
        }
        this.salarioPromedio = salarioPromedio;
        
        /**********************************************************
         * Obtención de los salarios minimos diarios nominales.   *
         **********************************************************/

        //Para el primer año
        salarioMinDiarioNominal[0] = Constantes.SALARIO_MINIMO_ANIO_BASE *(1+incRealSalMinimo[0])*(1+inflacionAnual[0]);

        //Para los demas años
        for(int año=1;año<salarioMinDiarioNominal.length;año++){
            salarioMinDiarioNominal[año]=salarioMinDiarioNominal[año-1]*(1+incRealSalMinimo[año])*(1+inflacionAnual[año]);
        }

        this.salMinDiarioNominal = salarioMinDiarioNominal;

        /**************************************************
         * Proyección de los salarios reales al año base   *
         **************************************************/

        //Para el primer año
        for(int i=0;i<proySalReales[0].length;i++){
            proySalReales[0][i] = salarioReal[i]*(1+incRealSalarios[0]);
        }

        //Para los demas años
        for(int año=1;año<proySalReales.length;año++){
            for(int edad=0;edad<proySalReales[0].length;edad++){
                proySalReales[año][edad] = proySalReales[año-1][edad]*(1+incRealSalarios[año]);
            }
        }
        this.proySalariosReales = proySalReales;



        /***********************************************
         * Obtención de la inflacion anual acumulada   *
         ***********************************************/

        //Para el primer año
        inflacionAnualAcumulada[0]= 1+inflacionAnual[0];

        //Para los demas años
        for(int año=1;año<inflacionAnualAcumulada.length;año++){
            inflacionAnualAcumulada[año] = inflacionAnualAcumulada[año-1]*(1+inflacionAnual[año]);
        }

        this.inflacionAnualAcumulada = inflacionAnualAcumulada;

        /**************************************************
         * Obtención de los salarios reales al año base.  *
         **************************************************/

        //Para el primer año
        salariosReales[0] = Constantes.SALARIO_MINIMO_ANIO_BASE *(1+incRealSalMinimo[0]);

        //Para los demas años
        for(int año=1;año<salariosReales.length;año++){
            salariosReales[año]=salariosReales[año-1]*(1+incRealSalMinimo[año]);
        }
        this.salariosReales = salariosReales;

    }

    public double[] getSalMinDiarioNominal() {
        return salMinDiarioNominal;
    }

    public double[][] getSalarioPromedio() {
        return salarioPromedio;
    }

    public double[] getInflacionAnualAcumulada() {
        return inflacionAnualAcumulada;
    }

    public double[] getSalariosReales() {
        return salariosReales;
    }

    public double[] getCtiaPromViudasDecimoCuarto() {
        return ctiaPromViudasDecimoCuarto;
    }

    public double[] getCuantiaPromPensionados() {
        return cuantiaPromPensionados;
    }

    public double[] getCuantiaPromViudas() {
        return cuantiaPromViudas;
    }

    public double[] getCuantiaPromHuerfyAsc() {
        return cuantiaPromHuerfyAsc;
    }

    public double[] getVolumenPensionAscendientesCeve() {
        return volumenPensionAscendientesCeve;
    }

    public double[] getVolumenPensionAscendientesInv() {
        return volumenPensionAscendientesInv;
    }

    public double[] getVolumenPensionHuerfanosCeve() {
        return volumenPensionHuerfanosCeve;
    }

    public double[] getVolumenPensionHuerfanosInv() {
        return volumenPensionHuerfanosInv;
    }

    public double[] getVolumenPensionTitularesCeve() {
        return volumenPensionTitularesCeve;
    }

    public double[] getVolumenPensionTitularesInv() {
        return volumenPensionTitularesInv;
    }

    public double[] getVolumenPensionViudasCeve() {
        return volumenPensionViudasCeve;
    }

    public double[] getVolumenPensionViudasInv() {
        return volumenPensionViudasInv;
    }


    public double[][] getProySalariosReales() {
        return proySalariosReales;
    }

    public double[] getVolumenPensionAscendientesMte() {
        return volumenPensionAscendientesMte;
    }

    public double[] getVolumenPensionHuerfanosMte() {
        return volumenPensionHuerfanosMte;
    }

    public double[] getVolumenPensionViudasMte() {
        return volumenPensionViudasMte;
    }

    public double[] getVolumenPensionAscendientesIP100() {
        return volumenPensionAscendientesIP100;
    }

    public double[] getVolumenPensionHuerfanosIP100() {
        return volumenPensionHuerfanosIP100;
    }

    public double[] getVolumenPensionTitularesIP100() {
        return volumenPensionTitularesIP100;
    }

    public double[] getVolumenPensionViudasIP100() {
        return volumenPensionViudasIP100;
    }

    public double[] getVolumenPensionAscendientesIPMenor100() {
        return volumenPensionAscendientesIPMenor100;
    }

    public double[] getVolumenPensionHuerfanosIPMenor100() {
        return volumenPensionHuerfanosIPMenor100;
    }

    public double[] getVolumenPensionTitularesIPMenor100() {
        return volumenPensionTitularesIPMenor100;
    }

    public double[] getVolumenPensionViudasIPMenor100() {
        return volumenPensionViudasIPMenor100;
    }

    public double[] getVolumenPensionAscendientesIPMenor50() {
        return volumenPensionAscendientesIPMenor50;
    }

    public double[] getVolumenPensionHuerfanosIPMenor50() {
        return volumenPensionHuerfanosIPMenor50;
    }

    public double[] getVolumenPensionTitularesIPMenor50() {
        return volumenPensionTitularesIPMenor50;
    }

    public double[] getVolumenPensionViudasIPMenor50() {
        return volumenPensionViudasIPMenor50;
    }

    public double[] getVolumenPensionAscendientesMteRT() {
        return volumenPensionAscendientesMteRT;
    }

    public double[] getVolumenPensionHuerfanosMteRT() {
        return volumenPensionHuerfanosMteRT;
    }

    public double[] getVolumenPensionViudasMteRT() {
        return volumenPensionViudasMteRT;
    }

    public double[] getVolumenPensionAscendientesInvTemp() {
        return volumenPensionAscendientesInvTemp;
    }

    public double[] getVolumenPensionHuerfanosInvTemp() {
        return volumenPensionHuerfanosInvTemp;
    }    

    public double[] getVolumenPensionViudasInvTemp() {
        return volumenPensionViudasInvTemp;
    }

    public double getVolPenFinAnio() {
        return volPenFinAnio;
    }

    public double getVolPenTempSobaniocompleto() {
        return volPenTempSobaniocompleto;
    }

    public double getVolPensTemDefMitadAnio() {
        return volPensTemDefMitadAnio;
    }

    public double getVolPensTemDefFinalAnio() {
        return VolPensTemDefFinalAnio;
    }

    public double[] getVolumenPensTemDefFinalAnio() {
        return VolumenPensTemDefFinalAnio;
    }

    public double[] getVolumenPensTemDefFinalAnioIP100() {
        return VolumenPensTemDefFinalAnioIP100;
    }

    public double[] getVolumenPensTemDefFinalAnioIPMenor100() {
        return VolumenPensTemDefFinalAnioIPMenor100;
    }

    public double[] getVolumenPensTemDefFinalAnioIPMenor50() {
        return VolumenPensTemDefFinalAnioIPMenor50;
    }

    public double[] getVolumenPensionAscendientesTempIP100() {
        return volumenPensionAscendientesTempIP100;
    }

    public double[] getVolumenPensionAscendientesTempIPMenor100() {
        return volumenPensionAscendientesTempIPMenor100;
    }

    public double[] getVolumenPensionAscendientesTempIPMenor50() {
        return volumenPensionAscendientesTempIPMenor50;
    }

    public double[] getVolumenPensionHuerfanosTempIP100() {
        return volumenPensionHuerfanosTempIP100;
    }

    public double[] getVolumenPensionHuerfanosTempIPMenor100() {
        return volumenPensionHuerfanosTempIPMenor100;
    }

    public double[] getVolumenPensionHuerfanosTempIPMenor50() {
        return volumenPensionHuerfanosTempIPMenor50;
    }

    public double[] getVolumenPensionViudasTempIP100() {
        return volumenPensionViudasTempIP100;
    }

    public double[] getVolumenPensionViudasTempIPMenor100() {
        return volumenPensionViudasTempIPMenor100;
    }

    public double[] getVolumenPensionViudasTempIPMenor50() {
        return volumenPensionViudasTempIPMenor50;
    }

   

    

    

    

    

    

    

   

    

    

    

    

    


    







}
