/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ProyeccionPensionados;

/**
 *
 * @author Antonio-Alcalde
 */
import Librerias.FuncionesMatematicas;

public class ProyeccionDemografica {

    private double[][] aseguradosCotizan;
    private double[][] aseguradosNoCotizan;
    private double[][] aseguradosVigentes;
    private double[][] probActivosMte;
    private double[][] probHuefanos;
    private double[][] probActivosMteCeVe;

    private double[][] pensionadosMitadAnio;
    private double[][] pensionadosFinalAnio;
    private double[][] pensionadosFallecidos;

    private double[][] pensionadosTempMitadAnio;
    private double[][] pensionadosTempFinalAnio;
    private double[][] pensionadosTempFallecidos;


    private double[][] nuevasViudasCadaAnio;
    private double[][] viudasSobrevivenCadaAnio;
    private double[][] viudasSobrevivenFinalAnio;
    private double[][] nuevasviudasFallecenMitadAnio;
    private double[][] viudasFallecenCadaAnio;

    private double[][] nuevosHuerfanosCadaAnio;
    private double[][] huerfanosSobrevivenCadaAnio;
    private double[][] huerfanosSobrevivenFinalAnio;
    private double[][] nuevosHuerfanosFallecenMitadAnio;
    private double[][] huerfanosFallecenCadaAnio;

    private double[][] nuevosAscendientesCadaAnio;
    private double[][] ascendientesSobrevivenCadaAnio;
    private double[][] ascendientesSobrevivenFinalAnio;
    private double[][] nuevosAscendientesFallecenMitadAnio;
    private double[][] ascendientesFallecenCadaAnio;

    private double[] totalPensionadosVigentesInv = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesViudezVigentesInv = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesInv = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesInv = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] totalPensionadosVigentesCeve = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesViudezVigentesCeve = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesCeve = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesCeve = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] totalPensionesViudezVigentesMte= new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesMte= new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesMte = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] totalPensionadosVigentesIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesViudezVigentesIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesIP100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesIP100 = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] totalPensionadosVigentesIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesViudezVigentesIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] totalPensionadosVigentesIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesViudezVigentesIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1];

    //Temporales
    private double[] totalPensionadosVigentesInvTemp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesViudezVigentesInvTemp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesInvTemp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesInvTemp = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] pensionadosSobAnioCompInvTemp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] pensionadosTemDefInvTemp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] pensionadosTemDefFinaAnioInvTemp = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] totalPensionadosVigentesIP100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesViudezVigentesIP100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesIP100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesIP100Temp = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] pensionadosSobAnioCompIP100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] pensionadosTemDefIP100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] pensionadosTemDefFinaAnioIP100Temp = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] totalPensionadosVigentesIPMenor100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesViudezVigentesIPMenor100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesIPMenor100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesIPMenor100Temp = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] pensionadosSobAnioCompIPMenor100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] pensionadosTemDefIPMenor100Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] pensionadosTemDefFinaAnioIPMenor100Temp = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] totalPensionadosVigentesIPMenor50Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesViudezVigentesIPMenor50Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesOrfandadVigentesIPMenor50Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] totalPensionesAscendenciaVigentesIPMenor50Temp = new double[Constantes.ANIOS_PROYECCION-1];

    private double[] pensionadosSobAnioCompIPMenor50Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] pensionadosTemDefIPMenor50Temp = new double[Constantes.ANIOS_PROYECCION-1];
    private double[] pensionadosTemDefFinaAnioIPMenor50Temp = new double[Constantes.ANIOS_PROYECCION-1];





    public void obtenerAseguradosVigentesCadaAnio(double[][] aseguradosBase,
                                                  double[][] probSobrevivencia,
                                                  double[]   densidadCotizacion){

        double[][] asegCotizan;
        double[][] asegNoCotizan;

        //Objetos a utilizar
        FuncionesMatematicas fm = new FuncionesMatematicas();

        /******************************************
         * Obtenemos los asegurados que cotizan   *
         ******************************************/
        asegCotizan = obtenerAseguradosCotizan(aseguradosBase,
                                               densidadCotizacion);

        /*******************************************
         * Obtenmos los asegurados que no cotizan. *
         *******************************************/
        asegNoCotizan = obtenerAseguradosNoCotizan(aseguradosBase,
                                                   densidadCotizacion);

        /*******************************************
         * Obtenemos a los asegurados vigentes.    *
         *******************************************/
        obtenerAseguradosVigentes(asegCotizan,
                                  asegNoCotizan,
                                  probSobrevivencia);

    }

    public void obtenerProyeccionPensionados(double[][] aseguradosBase,
                                             double[][] probSobrevivencia,
                                             double[][] distViudas,
                                             double[][] distHuerf,
                                             double[][] distAsc,
                                             double[][] probMteAct,
                                             double[][] probSobHuerf,
                                             double[][] probMtePensionados,
                                             double[]   probEntradaPension,
                                             double[]   densidadCotizacion,
                                             double     ERDefL73,
                                             int        anioProy,
                                             String     seguro,
                                             String     pension){

        double[][] penFinAnio;
        double[][] penFallecidos;

        double[][] nuevasViudas;
        double[][] nuevosHuerfanos;
        double[][] nuevosAscendientes;

        double[][] viudasFallecenSegMitadAnio;
        double[][] huerfanosFallecenSegMitadAnio;
        double[][] ascendientesFallecenSegMitadAnio;

        double[][] viudasSobrevivenFinalAnio;
        double[][] huerfanosSobrevivenFinalAnio;
        double[][] ascendientesSobrevivenFinalAnio;

        double[][] viudasSobCadaAnio;
        double[][] huerfanosSobCadaAnio;
        double[][] ascendientesSobCadaAnio;
        
        double[][] viudasFallecenCadaAnio;
        double[][] huerfanosFallecenCadaAnio;
        double[][] ascendientesFallecenCadaAnio;

        double[][] penMitadAnio;
        

        //temporales
        double[][] penTempFinAnio;
        double[][] penTempFallecidos;
        double[] penTempMitadAnio;

        boolean esMuerte;


        //Objetos a utilizar
        FuncionesMatematicas fm = new FuncionesMatematicas();

        //Bandera de muerte
        if(pension.equals("muerte")){
            esMuerte = true;
        }else{
            esMuerte = false;
        }


        /*********************************************************************
         * Obtenemos a los pensionados a mitad y final del año definitivos   *
         *********************************************************************/
        penMitadAnio = obtenerPensionadosMitadAnio(aseguradosBase,
                                                   probSobrevivencia,
                                                   densidadCotizacion,
                                                   probEntradaPension,
                                                   ERDefL73,
                                                   pension);
        
        penFinAnio = obtenerPensionadosFinalAnio(probMtePensionados,
                                                 fm.sumaMatriz(penMitadAnio),
                                                 pension);        

        /*****************************************************
         *       Obtenemos a los pensionados fallecidos      *
         *****************************************************/
        
        penFallecidos = obtenerPensionadosFallecidos(penFinAnio,
                                                     probMtePensionados,
                                                     fm.sumaMatriz(penMitadAnio), 
                                                     pension);
                       
                /*************************************************************************
                 *          Obtenemos a las derivadas de los pensionados Fallecidos      *
                 *************************************************************************/
        /**********************************************************************************************
         *       Obtenemos las nuevas viudas,huerfanos y ascendientes en cada año de proyección      *
         **********************************************************************************************/

        nuevasViudas = obtenerNvasViuHuerAscCdaAñoProyeccion(penFallecidos,
                                                             distViudas);

        this.nuevasViudasCadaAnio = nuevasViudas;       

        
        nuevosHuerfanos = obtenerNvasViuHuerAscCdaAñoProyeccion(penFallecidos,
                                                                distHuerf);

        this.nuevosHuerfanosCadaAnio = nuevosHuerfanos;

        
        nuevosAscendientes = obtenerNvasViuHuerAscCdaAñoProyeccion(penFallecidos,
                                                                   distAsc);

        this.nuevosAscendientesCadaAnio = nuevosAscendientes;

        /***************************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que fallecen en la segunda mitad del año    *
         ***************************************************************************************************/

        viudasFallecenSegMitadAnio = obtenerViuHuerAscFallecenSegundaMitadAnio(nuevasViudas,
                                                                               probMteAct,
                                                                               true,//Indica son ProbAct
                                                                               esMuerte);//Indicamos si el metodo es muerte
                                                      

        this.nuevasviudasFallecenMitadAnio = viudasFallecenSegMitadAnio;
   


        huerfanosFallecenSegMitadAnio = obtenerViuHuerAscFallecenSegundaMitadAnio(nuevosHuerfanos,
                                                                                  probSobHuerf,
                                                                                  false,//indica son ProbHuer
                                                                                  esMuerte);//Indicamos si el metodo es muerte

        this.nuevosHuerfanosFallecenMitadAnio = huerfanosFallecenSegMitadAnio;



        ascendientesFallecenSegMitadAnio = obtenerViuHuerAscFallecenSegundaMitadAnio(nuevosAscendientes,
                                                                                     probMteAct,
                                                                                     true,//Indica son ProbAct
                                                                                     esMuerte);//Indicamos si el metodo es muerte

        this.nuevosAscendientesFallecenMitadAnio = ascendientesFallecenSegMitadAnio;


        /**************************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que sobreviven al final de cada año        *
         **************************************************************************************************/

        viudasSobrevivenFinalAnio = obtenerViuHuerAscSobFinalAño(nuevasViudas,
                                                                 probMteAct,
                                                                 true,//Indica son ProbAct
                                                                 esMuerte);


        this.viudasSobrevivenFinalAnio = viudasSobrevivenFinalAnio;


        huerfanosSobrevivenFinalAnio = obtenerViuHuerAscSobFinalAño(nuevosHuerfanos,
                                                                    probSobHuerf,
                                                                    false,//indica son ProbHuer
                                                                    esMuerte);

        this.huerfanosSobrevivenFinalAnio = huerfanosSobrevivenFinalAnio;


        ascendientesSobrevivenFinalAnio = obtenerViuHuerAscSobFinalAño(nuevosAscendientes,
                                                                       probMteAct,
                                                                       true,//Indica son ProbAct
                                                                       esMuerte);

        this.ascendientesSobrevivenFinalAnio = ascendientesSobrevivenFinalAnio;

        
        /*****************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que sobreviven en cada año        *
         *****************************************************************************************/

        viudasSobCadaAnio = obtenerViuHuerAscSobCadaAnio(viudasSobrevivenFinalAnio,
                                                         probMteAct,
                                                         true);//Indica son ProbAct
        
        this.viudasSobrevivenCadaAnio = viudasSobCadaAnio;


        huerfanosSobCadaAnio = obtenerViuHuerAscSobCadaAnio(huerfanosSobrevivenFinalAnio,
                                                            probSobHuerf,
                                                            false);//indica son ProbHuer

        this.huerfanosSobrevivenCadaAnio = huerfanosSobCadaAnio;

        ascendientesSobCadaAnio = obtenerViuHuerAscSobCadaAnio(ascendientesSobrevivenFinalAnio,
                                                               probMteAct,
                                                               true);//Indica son ProbAct

        this.ascendientesSobrevivenCadaAnio = ascendientesSobCadaAnio;

        
        /*****************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que fallecen en cada año          *
         *****************************************************************************************/

        viudasFallecenCadaAnio = obtenerViuHuerAscFallecenCadaAnio(viudasSobrevivenFinalAnio,
                                                                   viudasSobCadaAnio,
                                                                   probMteAct,
                                                                   true);
        
        this.viudasFallecenCadaAnio = viudasFallecenCadaAnio;

        huerfanosFallecenCadaAnio = obtenerViuHuerAscFallecenCadaAnio(huerfanosSobrevivenFinalAnio,
                                                                      huerfanosSobCadaAnio,
                                                                      probSobHuerf,
                                                                      false);

        this.huerfanosFallecenCadaAnio = huerfanosFallecenCadaAnio;

        ascendientesFallecenCadaAnio = obtenerViuHuerAscFallecenCadaAnio(ascendientesSobrevivenFinalAnio,
                                                                         ascendientesSobCadaAnio,
                                                                         probMteAct,
                                                                         true);
        
        this.ascendientesFallecenCadaAnio = ascendientesFallecenCadaAnio;

        /*********************************************************************
         *      Obtencion de acumulados para generar resumen del SRT y SIV   *
         *********************************************************************/

        if(seguro.equals("IV")){

            for(int i=1;i<(Constantes.ANIOS_PROYECCION-1)-anioProy;i++){

            (pension.equals("inv")?totalPensionadosVigentesInv:totalPensionadosVigentesCeve)[i+anioProy]+=fm.sumaVector(penFinAnio[i]);
            (pension.equals("inv")?totalPensionesViudezVigentesInv:totalPensionesViudezVigentesCeve)[i+anioProy]+=fm.sumaVector(viudasSobrevivenFinalAnio[i]) + fm.sumaVector(viudasSobCadaAnio[i]);
            (pension.equals("inv")?totalPensionesOrfandadVigentesInv:totalPensionesOrfandadVigentesCeve)[i+anioProy]+=fm.sumaVector(huerfanosSobrevivenFinalAnio[i]) + fm.sumaVector(huerfanosSobCadaAnio[i]);
            (pension.equals("inv")?totalPensionesAscendenciaVigentesInv:totalPensionesAscendenciaVigentesCeve)[i+anioProy]+=fm.sumaVector(ascendientesSobrevivenFinalAnio[i]) + fm.sumaVector(ascendientesSobCadaAnio[i]);

            }
        }else{

            for(int i=1;i<(Constantes.ANIOS_PROYECCION-1)-anioProy;i++){

            (pension.equals("ip100")?totalPensionadosVigentesIP100:pension.equals("ipMenor100")?totalPensionadosVigentesIPMenor100:totalPensionadosVigentesIPMenor50)[i+anioProy]+=fm.sumaVector(penFinAnio[i]);
            (pension.equals("ip100")?totalPensionesViudezVigentesIP100:pension.equals("ipMenor100")?totalPensionesViudezVigentesIPMenor100:totalPensionesViudezVigentesIPMenor50)[i+anioProy]+=fm.sumaVector(viudasSobrevivenFinalAnio[i]) + fm.sumaVector(viudasSobCadaAnio[i]);
            (pension.equals("ip100")?totalPensionesOrfandadVigentesIP100:pension.equals("ipMenor100")?totalPensionesOrfandadVigentesIPMenor100:totalPensionesOrfandadVigentesIPMenor50)[i+anioProy]+=fm.sumaVector(huerfanosSobrevivenFinalAnio[i]) + fm.sumaVector(huerfanosSobCadaAnio[i]);
            (pension.equals("ip100")?totalPensionesAscendenciaVigentesIP100:pension.equals("ipMenor100")?totalPensionesAscendenciaVigentesIPMenor100:totalPensionesAscendenciaVigentesIPMenor50)[i+anioProy]+=fm.sumaVector(ascendientesSobrevivenFinalAnio[i]) + fm.sumaVector(ascendientesSobCadaAnio[i]);

            }

            

        }                    
        


        //imprimir matrices en pantalla
/**
        for (int fila = 0; fila < ascendientesFallecenCadaAnio.length; fila++) {
            for (int colum = 0; colum < ascendientesFallecenCadaAnio[0].length; colum++) {
                System.out.print(ascendientesFallecenCadaAnio[fila][colum]);
                System.out.print(",");
            }
            System.out.println();
        }

        System.out.println();*/

        
    }//Termina metodo proyeccion de asegurados

    public void obtenerProyeccionPensionadosTemporales(double[][] aseguradosBase,
                                                       double[][] probSobrevivencia,
                                                       double[][] distViudas,
                                                       double[][] distHuerf,
                                                       double[][] distAsc,
                                                       double[][] probMteAct,
                                                       double[][] probSobHuerf,
                                                       double[][] probMtePensionados,
                                                       double[]   probEntradaPension,
                                                       double[]   densidadCotizacion,
                                                       double[]   eleccionMteL73Temp,
                                                       double     eleccReg,
                                                       double     eleccRegTempDef,
                                                       int        anioProy,
                                                       String     seguro,
                                                       String     pension){

        double[][] penFinAnio;
        double[][] penFallecidos;

        double[][] nuevasViudas;
        double[][] nuevosHuerfanos;
        double[][] nuevosAscendientes;

        double[][] viudasFallecenSegMitadAnio;
        double[][] huerfanosFallecenSegMitadAnio;
        double[][] ascendientesFallecenSegMitadAnio;

        double[][] viudasSobrevivenFinalAnio;
        double[][] huerfanosSobrevivenFinalAnio;
        double[][] ascendientesSobrevivenFinalAnio;

        double[][] viudasSobCadaAnio;
        double[][] huerfanosSobCadaAnio;
        double[][] ascendientesSobCadaAnio;

        double[][] viudasFallecenCadaAnio;
        double[][] huerfanosFallecenCadaAnio;
        double[][] ascendientesFallecenCadaAnio;

        double[][] penMitadAnio;       

        boolean esMuerte;


        //Objetos a utilizar
        FuncionesMatematicas fm = new FuncionesMatematicas();

        //Bandera de muerte
        if(pension.equals("muerte")){
            esMuerte = true;
        }else{
            esMuerte = false;
        }


        /*********************************************************************
         * Obtenemos a los pensionados a mitad y final del año definitivos   *
         *********************************************************************/
        penMitadAnio = obtenerPensionadosMitadAnio(aseguradosBase,
                                                   probSobrevivencia,
                                                   densidadCotizacion,
                                                   probEntradaPension,
                                                   eleccReg,
                                                   pension);        

        penFinAnio = obtenerPensionadosTempFinalAnio(fm.sumaMatriz(penMitadAnio),
                                                     probMtePensionados[0],
                                                     eleccRegTempDef);        

        /*****************************************************
         *       Obtenemos a los pensionados fallecidos      *
         *****************************************************/

        penFallecidos = obtenerPensTempFallecidos(penFinAnio,
                                                  fm.sumaMatriz(penMitadAnio),
                                                  probMtePensionados[0],
                                                  eleccionMteL73Temp,
                                                  anioProy);    

                /*************************************************************************
                 *          Obtenemos a las derivadas de los pensionados Fallecidos      *
                 *************************************************************************/
        /**********************************************************************************************
         *       Obtenemos las nuevas viudas,huerfanos y ascendientes en cada año de proyección      *
         **********************************************************************************************/

        nuevasViudas = obtenerNvasViuHuerAscTempCdaAñoProyeccion(penFallecidos,
                                                                 distViudas);

        this.nuevasViudasCadaAnio = nuevasViudas;
       
        nuevosHuerfanos = obtenerNvasViuHuerAscTempCdaAñoProyeccion(penFallecidos,
                                                                    distHuerf);

        this.nuevosHuerfanosCadaAnio = nuevosHuerfanos;


        nuevosAscendientes = obtenerNvasViuHuerAscTempCdaAñoProyeccion(penFallecidos,
                                                                       distAsc);

        this.nuevosAscendientesCadaAnio = nuevosAscendientes;

        /***************************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que fallecen en la segunda mitad del año    *
         ***************************************************************************************************/

        viudasFallecenSegMitadAnio = obtenerViuHuerAscFallecenSegundaMitadAnio(nuevasViudas,
                                                                               probMteAct,
                                                                               true,//Indica son ProbAct
                                                                               esMuerte);//Indicamos si el metodo es muerte


        this.nuevasviudasFallecenMitadAnio = viudasFallecenSegMitadAnio;

         
        huerfanosFallecenSegMitadAnio = obtenerViuHuerAscFallecenSegundaMitadAnio(nuevosHuerfanos,
                                                                                  probSobHuerf,
                                                                                  false,//indica son ProbHuer
                                                                                  esMuerte);//Indicamos si el metodo es muerte

        this.nuevosHuerfanosFallecenMitadAnio = huerfanosFallecenSegMitadAnio;



        ascendientesFallecenSegMitadAnio = obtenerViuHuerAscFallecenSegundaMitadAnio(nuevosAscendientes,
                                                                                     probMteAct,
                                                                                     true,//Indica son ProbAct
                                                                                     esMuerte);//Indicamos si el metodo es muerte

        this.nuevosAscendientesFallecenMitadAnio = ascendientesFallecenSegMitadAnio;


        /**************************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que sobreviven al final de cada año        *
         **************************************************************************************************/

        viudasSobrevivenFinalAnio = obtenerViuHuerAscSobFinalAño(nuevasViudas,
                                                                 probMteAct,
                                                                 true,//Indica son ProbAct
                                                                 esMuerte);

        this.viudasSobrevivenFinalAnio = viudasSobrevivenFinalAnio;

        
        huerfanosSobrevivenFinalAnio = obtenerViuHuerAscSobFinalAño(nuevosHuerfanos,
                                                                    probSobHuerf,
                                                                    false,//indica son ProbHuer
                                                                    esMuerte);

        this.huerfanosSobrevivenFinalAnio = huerfanosSobrevivenFinalAnio;


        ascendientesSobrevivenFinalAnio = obtenerViuHuerAscSobFinalAño(nuevosAscendientes,
                                                                       probMteAct,
                                                                       true,//Indica son ProbAct
                                                                       esMuerte);

        this.ascendientesSobrevivenFinalAnio = ascendientesSobrevivenFinalAnio;


        /*****************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que sobreviven en cada año        *
         *****************************************************************************************/

        viudasSobCadaAnio = obtenerViuHuerAscSobCadaAnio(viudasSobrevivenFinalAnio,
                                                         probMteAct,
                                                         true);//Indica son ProbAct

        this.viudasSobrevivenCadaAnio = viudasSobCadaAnio;
        

        huerfanosSobCadaAnio = obtenerViuHuerAscSobCadaAnio(huerfanosSobrevivenFinalAnio,
                                                            probSobHuerf,
                                                            false);//indica son ProbHuer

        this.huerfanosSobrevivenCadaAnio = huerfanosSobCadaAnio;
        


        ascendientesSobCadaAnio = obtenerViuHuerAscSobCadaAnio(ascendientesSobrevivenFinalAnio,
                                                               probMteAct,
                                                               true);//Indica son ProbAct

        this.ascendientesSobrevivenCadaAnio = ascendientesSobCadaAnio;

        

        /*****************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que fallecen en cada año          *
         *****************************************************************************************/

        viudasFallecenCadaAnio = obtenerViuHuerAscFallecenCadaAnio(viudasSobrevivenFinalAnio,
                                                                   viudasSobCadaAnio,
                                                                   probMteAct,
                                                                   true);

        this.viudasFallecenCadaAnio = viudasFallecenCadaAnio;
        

        huerfanosFallecenCadaAnio = obtenerViuHuerAscFallecenCadaAnio(huerfanosSobrevivenFinalAnio,
                                                                      huerfanosSobCadaAnio,
                                                                      probSobHuerf,
                                                                      false);

        this.huerfanosFallecenCadaAnio = huerfanosFallecenCadaAnio;
        

        ascendientesFallecenCadaAnio = obtenerViuHuerAscFallecenCadaAnio(ascendientesSobrevivenFinalAnio,
                                                                         ascendientesSobCadaAnio,
                                                                         probMteAct,
                                                                         true);

        this.ascendientesFallecenCadaAnio = ascendientesFallecenCadaAnio;

        
        /*********************************************************************
         *      Obtencion de acumulados para generar resumen del SRT y SIV   *
         *********************************************************************/

        if(seguro.equals("IV")){

            pensionadosSobAnioCompInvTemp[(anioProy+1<pensionadosSobAnioCompInvTemp.length ?anioProy+1:pensionadosSobAnioCompInvTemp.length-1)] = fm.sumaVector(penFinAnio[1]);
            pensionadosTemDefInvTemp[(anioProy+2<pensionadosTemDefInvTemp.length ?anioProy+2:pensionadosTemDefInvTemp.length-1)] = fm.sumaVector(penFinAnio[2]);

            for(int año=3;año<pensionadosTemDefFinaAnioInvTemp.length-anioProy;año++){
                pensionadosTemDefFinaAnioInvTemp[(anioProy+(año-1)<pensionadosTemDefFinaAnioInvTemp.length ?anioProy+(año-1):pensionadosTemDefFinaAnioInvTemp.length-1)] += fm.sumaVector(penFinAnio[año]);
            }

            for(int i=1;i<(Constantes.ANIOS_PROYECCION-1)-anioProy;i++){

            totalPensionadosVigentesInvTemp[i+anioProy]+=fm.sumaVector(penFinAnio[i]);
            totalPensionesViudezVigentesInvTemp[i+anioProy]+=fm.sumaVector(viudasSobrevivenFinalAnio[i]) + fm.sumaVector(viudasSobCadaAnio[i]);
            totalPensionesOrfandadVigentesInvTemp[i+anioProy]+=fm.sumaVector(huerfanosSobrevivenFinalAnio[i]) + fm.sumaVector(huerfanosSobCadaAnio[i]);
            totalPensionesAscendenciaVigentesInvTemp[i+anioProy]+=fm.sumaVector(ascendientesSobrevivenFinalAnio[i]) + fm.sumaVector(ascendientesSobCadaAnio[i]);

            } 
        }else{//Seguro de Riesgos de trabajo

            (pension.equals("ip100")?pensionadosSobAnioCompIP100Temp:pension.equals("ipMenor100")?pensionadosSobAnioCompIPMenor100Temp:pensionadosSobAnioCompIPMenor50Temp)
                                                                        [(anioProy+1<pensionadosSobAnioCompIP100Temp.length ?anioProy+1:pensionadosSobAnioCompIP100Temp.length-1)] = fm.sumaVector(penFinAnio[1]);

            (pension.equals("ip100")?pensionadosTemDefIP100Temp:pension.equals("ipMenor100")?pensionadosTemDefIPMenor100Temp:pensionadosTemDefIPMenor50Temp)
                                                                        [(anioProy+2<pensionadosTemDefIP100Temp.length ?anioProy+2:pensionadosTemDefIP100Temp.length-1)] = fm.sumaVector(penFinAnio[2]);

            for(int año=3;año<pensionadosTemDefFinaAnioIP100Temp.length-anioProy;año++){
                (pension.equals("ip100")?pensionadosTemDefFinaAnioIP100Temp:pension.equals("ipMenor100")?pensionadosTemDefFinaAnioIPMenor100Temp:pensionadosTemDefFinaAnioIPMenor50Temp)
                        [(anioProy+(año-1)<pensionadosTemDefFinaAnioIP100Temp.length ?anioProy+(año-1):pensionadosTemDefFinaAnioIP100Temp.length-1)] += fm.sumaVector(penFinAnio[año]);
            }

            for(int i=1;i<(Constantes.ANIOS_PROYECCION-1)-anioProy;i++){

                (pension.equals("ip100")?totalPensionadosVigentesIP100Temp:pension.equals("ipMenor100")?totalPensionadosVigentesIPMenor100Temp:totalPensionadosVigentesIPMenor50Temp)
                                                                            [i+anioProy]+=fm.sumaVector(penFinAnio[i]);
                
                (pension.equals("ip100")?totalPensionesViudezVigentesIP100Temp:pension.equals("ipMenor100")?totalPensionesViudezVigentesIPMenor100Temp:totalPensionesViudezVigentesIPMenor50Temp)
                                                                            [i+anioProy]+=fm.sumaVector(viudasSobrevivenFinalAnio[i]) + fm.sumaVector(viudasSobCadaAnio[i]);

                (pension.equals("ip100")?totalPensionesOrfandadVigentesIP100Temp:pension.equals("ipMenor100")?totalPensionesOrfandadVigentesIPMenor100Temp:totalPensionesOrfandadVigentesIPMenor50Temp)
                                                                            [i+anioProy]+=fm.sumaVector(huerfanosSobrevivenFinalAnio[i]) + fm.sumaVector(huerfanosSobCadaAnio[i]);

                (pension.equals("ip100")?totalPensionesAscendenciaVigentesIP100Temp:pension.equals("ipMenor100")?totalPensionesAscendenciaVigentesIPMenor100Temp:totalPensionesAscendenciaVigentesIPMenor50Temp)
                                                                            [i+anioProy]+=fm.sumaVector(ascendientesSobrevivenFinalAnio[i]) + fm.sumaVector(ascendientesSobCadaAnio[i]);

            }

        }
       
/**
        for (int fila = 0; fila < ascendientesFallecenCadaAnio.length; fila++) {
            for (int colum = 0; colum < ascendientesFallecenCadaAnio[0].length; colum++) {
                System.out.print(ascendientesFallecenCadaAnio[fila][colum]);
                System.out.print(",");
            }
            System.out.println();
        }

        System.out.println();*/


    }//Termina metodo proyeccion de asegurados

    public void obtenerProyeccionPensionadosMte(double[][] aseguradosBase,
                                                double[][] probSobrevivencia,
                                                double[][] distViudas,
                                                double[][] distHuerf,
                                                double[][] distAsc,
                                                double[][] probMteAct,
                                                double[][] probSobHuerf,
                                                double[]   probEntradaPension,
                                                double[]   densidadCotizacion,
                                                double     ERMte73,
                                                int        anioProy,
                                                String     pension){

        double[][] penFallecidos = new double[Constantes.ANIOS_PROYECCION-1][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        double[] vecAux;
        double[][] nuevasViudas;
        double[][] nuevosHuerfanos;
        double[][] nuevosAscendientes;

        double[][] viudasFallecenSegMitadAnio;
        double[][] huerfanosFallecenSegMitadAnio;
        double[][] ascendientesFallecenSegMitadAnio;

        double[][] viudasSobrevivenFinalAnio;
        double[][] huerfanosSobrevivenFinalAnio;
        double[][] ascendientesSobrevivenFinalAnio;

        double[][] viudasSobCadaAnio;
        double[][] huerfanosSobCadaAnio;
        double[][] ascendientesSobCadaAnio;

        double[][] viudasFallecenCadaAnio;
        double[][] huerfanosFallecenCadaAnio;
        double[][] ascendientesFallecenCadaAnio;

        double[][] penMitadAnio;
        boolean esMuerte;
        boolean esIPmenor100;


        //Objetos a utilizar
        FuncionesMatematicas fm = new FuncionesMatematicas();

        //Bandera de muerte
        if(pension.equals("mte")){
            esMuerte = true;
        }else{
            esMuerte = false;
        }        

        /*********************************************************************
         * Obtenemos a los pensionados a mitad y final del año definitivos   *
         *********************************************************************/
        penMitadAnio = obtenerPensionadosMitadAnio(aseguradosBase,
                                                   probSobrevivencia,
                                                   densidadCotizacion,
                                                   probEntradaPension,
                                                   ERMte73,
                                                   pension);

        vecAux = fm.sumaMatriz(penMitadAnio);

        //Llenamos unicamente el primer año de la matriz para procesarla en los sig. metodos
        for(int edad=0;edad<vecAux.length;edad++){
            penFallecidos[0][edad] = vecAux[edad];
        }
        
                /*************************************************************************
                 *          Obtenemos a las derivadas de los pensionados Fallecidos      *
                 *************************************************************************/
        /**********************************************************************************************
         *       Obtenemos las nuevas viudas,huerfanos y ascendientes en cada año de proyección       *
         **********************************************************************************************/

        nuevasViudas = obtenerNvasViuHuerAscCdaAñoProyeccion(penFallecidos,
                                                             distViudas);

        this.nuevasViudasCadaAnio = nuevasViudas;


        nuevosHuerfanos = obtenerNvasViuHuerAscCdaAñoProyeccion(penFallecidos,
                                                                distHuerf);

        this.nuevosHuerfanosCadaAnio = nuevosHuerfanos;


        nuevosAscendientes = obtenerNvasViuHuerAscCdaAñoProyeccion(penFallecidos,
                                                                   distAsc);

        this.nuevosAscendientesCadaAnio = nuevosAscendientes;

        /***************************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que fallecen en la segunda mitad del año    *
         ***************************************************************************************************/

        viudasFallecenSegMitadAnio = obtenerViuHuerAscFallecenSegundaMitadAnio(nuevasViudas,
                                                                               probMteAct,
                                                                               true,//Indica son ProbAct
                                                                               esMuerte);//Indicamos si el metodo es muerte
       

        this.nuevasviudasFallecenMitadAnio = viudasFallecenSegMitadAnio;


        huerfanosFallecenSegMitadAnio = obtenerViuHuerAscFallecenSegundaMitadAnio(nuevosHuerfanos,
                                                                                  probSobHuerf,
                                                                                  false,//indica son ProbHuer
                                                                                  esMuerte);//Indicamos si el metodo es muerte

        this.nuevosHuerfanosFallecenMitadAnio = huerfanosFallecenSegMitadAnio;



        ascendientesFallecenSegMitadAnio = obtenerViuHuerAscFallecenSegundaMitadAnio(nuevosAscendientes,
                                                                                     probMteAct,
                                                                                     true,//Indica son ProbAct
                                                                                     esMuerte);//Indicamos si el metodo es muerte

        this.nuevosAscendientesFallecenMitadAnio = ascendientesFallecenSegMitadAnio;


        /**************************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que sobreviven al final de cada año        *
         **************************************************************************************************/

        viudasSobrevivenFinalAnio = obtenerViuHuerAscSobFinalAño(nuevasViudas,
                                                                 probMteAct,
                                                                 true,//Indica son ProbAct
                                                                 esMuerte);

        this.viudasSobrevivenFinalAnio = viudasSobrevivenFinalAnio;


        huerfanosSobrevivenFinalAnio = obtenerViuHuerAscSobFinalAño(nuevosHuerfanos,
                                                                    probSobHuerf,
                                                                    false,//indica son ProbHuer
                                                                    esMuerte);

        this.huerfanosSobrevivenFinalAnio = huerfanosSobrevivenFinalAnio;


        ascendientesSobrevivenFinalAnio = obtenerViuHuerAscSobFinalAño(nuevosAscendientes,
                                                                       probMteAct,
                                                                       true,//Indica son ProbAct
                                                                       esMuerte);

        this.ascendientesSobrevivenFinalAnio = ascendientesSobrevivenFinalAnio;


        /*****************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que sobreviven en cada año        *
         *****************************************************************************************/

        viudasSobCadaAnio = obtenerViuHuerAscSobCadaAnio(viudasSobrevivenFinalAnio,
                                                         probMteAct,
                                                         true);//Indica son ProbAct

        this.viudasSobrevivenCadaAnio = viudasSobCadaAnio;


        huerfanosSobCadaAnio = obtenerViuHuerAscSobCadaAnio(huerfanosSobrevivenFinalAnio,
                                                            probSobHuerf,
                                                            false);//indica son ProbHuer

        this.huerfanosSobrevivenCadaAnio = huerfanosSobCadaAnio;

        ascendientesSobCadaAnio = obtenerViuHuerAscSobCadaAnio(ascendientesSobrevivenFinalAnio,
                                                               probMteAct,
                                                               true);//Indica son ProbAct

        this.ascendientesSobrevivenCadaAnio = ascendientesSobCadaAnio;


        /*****************************************************************************************
         *       Obtenemos las viudas,huerfanos y ascendientes que fallecen en cada año          *
         *****************************************************************************************/

        viudasFallecenCadaAnio = obtenerViuHuerAscFallecenCadaAnio(viudasSobrevivenFinalAnio,
                                                                   viudasSobCadaAnio,
                                                                   probMteAct,
                                                                   true);

        this.viudasFallecenCadaAnio = viudasFallecenCadaAnio;

        huerfanosFallecenCadaAnio = obtenerViuHuerAscFallecenCadaAnio(huerfanosSobrevivenFinalAnio,
                                                                      huerfanosSobCadaAnio,
                                                                      probSobHuerf,
                                                                      false);

        this.huerfanosFallecenCadaAnio = huerfanosFallecenCadaAnio;

        ascendientesFallecenCadaAnio = obtenerViuHuerAscFallecenCadaAnio(ascendientesSobrevivenFinalAnio,
                                                                         ascendientesSobCadaAnio,
                                                                         probMteAct,
                                                                         true);

        this.ascendientesFallecenCadaAnio = ascendientesFallecenCadaAnio;

        /*********************************************************************
         * Obtencion de acumulados para generar resumen de invalidez y CeVe  *
         *********************************************************************/
        for(int i=1;i<(Constantes.ANIOS_PROYECCION-1)-anioProy;i++){
            totalPensionesViudezVigentesMte[i+anioProy]+=fm.sumaVector(viudasSobrevivenFinalAnio[i]) + fm.sumaVector(viudasSobCadaAnio[i]);
            totalPensionesOrfandadVigentesMte[i+anioProy]+=fm.sumaVector(huerfanosSobrevivenFinalAnio[i]) + fm.sumaVector(huerfanosSobCadaAnio[i]);
            totalPensionesAscendenciaVigentesMte[i+anioProy]+=fm.sumaVector(ascendientesSobrevivenFinalAnio[i]) + fm.sumaVector(ascendientesSobCadaAnio[i]);
        }
    }






    /******************************************************************************************************
     *            Este método obtiene a los asegurados que cotizan en cada año de proyección.             *
     * @param asegBase: Asegurados base al inicio de cada año.                                            *
     * @param denCotizacion: Probabilidad de que un asegurado alcance un años mas de antiguedad y edad.   *
     * @return asegCotizaron: Asegurados que alcanzarón un años mas de antiguedad y edad.                 *
     ******************************************************************************************************/
    public double[][] obtenerAseguradosCotizan(double[][]asegBase,
                                               double[] denCotizacion){

        double[][] asegCotizaron = new double[asegBase.length][asegBase[0].length+1];

        for(int edad=0;edad<asegBase.length;edad++){
            for(int antiguedad=1;antiguedad<=asegBase[0].length;antiguedad++){
                asegCotizaron[edad][antiguedad]=asegBase[edad][antiguedad-1]*denCotizacion[edad];
            }
        }
        this.aseguradosCotizan = asegCotizaron;
        return asegCotizaron;
    }

    /*******************************************************************************************************
     *       Este método obtiene a los asegurados que no cotizan en cada año de proyección.                *
     * @param asegBase: Asegurados base al inicio de cada año.                                             *
     * @param denCotizacion: Probabilidad de que un asegurado alcance un años mas de antiguedad y edad.    *
     * @return asegNoCotizaron: Asegurados que no alcanzarón un años mas de antiguedad y edad.             *
     *******************************************************************************************************/
    public double[][] obtenerAseguradosNoCotizan(double[][]asegBase,
                                                 double[] denCotizacion){

        double[][] asegNoCotizaron = new double[asegBase.length][asegBase[0].length+1];

        for(int edad=0;edad<asegBase.length;edad++){
            for(int antiguedad=1;antiguedad<=asegBase[0].length;antiguedad++){
                if(antiguedad==51){
                    break;
                }
                asegNoCotizaron[edad][antiguedad]=asegBase[edad][antiguedad]*(1-denCotizacion[edad]);

            }
        }
        this.aseguradosNoCotizan = asegNoCotizaron;
        return asegNoCotizaron;
    }

    /******************************************************************************************************************
     *                Este método obtiene a los asegurados vigentes en cada año de proyección.                        *
     * @param asegCotizan: Asegurados que alcanzarón un años mas de antiguedad y edad.                                *
     * @param asegNoCotizan: Asegurados que no alcanzarón un años mas de antiguedad y edad.                           *
     * @param probSobrevivencia: Probabilidad de acuerdo a la antiguedad de que un asegurado sobreviva un año más.    *
     ******************************************************************************************************************/
    public void obtenerAseguradosVigentes(double[][] asegCotizan,
                                          double[][] asegNoCotizan,
                                          double[][] probSobrevivencia){

        double[][] aseguradosVigentes = new double[asegCotizan.length][asegCotizan[0].length-1];//solo hasta ant 50, 51 se ignora

        for(int edad=1;edad<asegCotizan.length;edad++){
            for(int antiguedad=0;antiguedad<asegCotizan[0].length-1;antiguedad++){
                aseguradosVigentes[edad][antiguedad]= asegCotizan[edad-1][antiguedad] + asegNoCotizan[edad-1][antiguedad];
                /**Una vez sumados a los asegurados que cotizan y no cotizan, estos se multiplican por*****
                *******las probabilidades de sobrevivencia de acuerdo a la antiguedad de cada uno.********/
                aseguradosVigentes[edad][antiguedad] *= probSobrevivencia[(antiguedad<=2?0:antiguedad<=9?1:2)][edad-1];
            }

        }
        this.aseguradosVigentes = aseguradosVigentes;


    }

    /******************************************************************************************************************
     *       Este método obtiene a los nuevos pensionados de invalidez o Ceve que ingresan a mitad del primer año     *
     * @param asegBase: Asegurados base al inicio de cada año.                                                        *
     * @param probEntPension: Probabilidad de que un asegurado se pensione por Invalidez o CeVe.                      *
     * @param proSob: Probabilidad de acuerdo a la antiguedad de que un asegurado sobreviva un año más.               *
     * @param densCot: Probabilidad de que un asegurado alcance un años mas de antiguedad y edad.                     *
     * @param defL73: Probabilidades de que un asegurado elija la ley de 1973.                                        *
     * @return nvosPenMitadAnio: Nuevos pensionados que ingresaron a mitad del primer año.                            *                                                 *
     ******************************************************************************************************************/
    public double[][] obtenerPensionadosMitadAnio(double[][] asegBase,
                                                  double[][] proSob,
                                                  double[]   densCot,
                                                  double[]   probEntPension,
                                                  double     EleccionReg,
                                                  String     pension) {

        double[][] nvosPenMitadAnio = new double[asegBase.length][asegBase[0].length];

        //creamos objeto que se necesita para realizar operaciones matematicas
        FuncionesMatematicas fm = new FuncionesMatematicas();

        for(int edad=0;edad<asegBase.length;edad++){
            for(int ant=0;ant<asegBase[0].length;ant++){
                if (edad < Constantes.EDAD_MAXIMA_ASEGURADO - Constantes.EDAD_MINIMA_ASEGURADO) {//edades menores a 89
                    if(ant < 50){//antiguedades menores a 50
                        nvosPenMitadAnio[edad][ant] = asegBase[edad][ant] * probEntPension[edad] * EleccionReg;
                    }else{//antiguedades iguales a 50 y edades menores a 89
                        nvosPenMitadAnio[edad][ant] = asegBase[edad][ant]*(1+proSob[2][edad]* densCot[edad])
                                                    * probEntPension[edad] * EleccionReg;
                    }
                    
                } else {//edad 89
                    if(ant<=2){
                        nvosPenMitadAnio[edad][ant] = asegBase[edad][ant]*(1+proSob[0][edad]* densCot[edad])
                                                    * probEntPension[edad] * EleccionReg;
                    }else if(ant<=9){
                         nvosPenMitadAnio[edad][ant] = asegBase[edad][ant]*(1+proSob[1][edad]* densCot[edad])
                                                    * probEntPension[edad] * EleccionReg;
                    }else{
                        nvosPenMitadAnio[edad][ant] = asegBase[edad][ant]*(1+proSob[2][edad]* densCot[edad])
                                                    * probEntPension[edad] * EleccionReg;
                    }

                }//fin else edad 89


            }//fin for
        }//fin for
        this.pensionadosMitadAnio = (pension.equals("ceve")?fm.delimitarMatriz(nvosPenMitadAnio, 10):nvosPenMitadAnio);
        return (pension.equals("ceve")?fm.delimitarMatriz(nvosPenMitadAnio, 10):nvosPenMitadAnio);
        

    }

    /*****************************************************************************************************************
     *    Este método obtiene a los nuevos pensionados que sobreviven al final del primer año de proyección.         *
     * @param penMitadAnio: Nuevos pensionados de invalidez y CeVe que ingresaron a mitad del año.                   *
     * @param probMteInv: Probabilidad de que un pensionado fallezca.                                                *
     * @return penFinAnio: Pensionados que sobreviven al final del año.                                              *
     *****************************************************************************************************************/
    public double[][] obtenerPensionadosFinalAnio(double[][] probMte,
                                                  double[]   penMitadAnio,
                                                  String     pension){

        double[][] penFinAnio = new double[Constantes.ANIOS_PROYECCION-1][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];
        boolean bandera = (pension.equals("ceve")?false:true);//utilizo prob de activos o de inc/inv

        //Para el primer Año de proyección
        for(int edad=1;edad<=penMitadAnio.length;edad++){
                
                penFinAnio[0][edad]=penMitadAnio[edad-1]*((2*(1-probMte[0][(bandera?edad-1:edad+14)]))/(1+(1-probMte[0][(bandera?edad-1:edad+14)])));
        }

        //Para los demas años
        for(int año=1;año<penFinAnio.length;año++){
            for(int edad=1;edad<penFinAnio[0].length;edad++){
                
                penFinAnio[año][edad]=penFinAnio[año-1][edad-1]*(1-probMte[(bandera?0:año)][(bandera?edad-1:edad+14)]);

            }
        }
        this.pensionadosFinalAnio = penFinAnio;
        return penFinAnio;
    }

    /***********************************
     * Pensionados temporales final año
     ************************************/

    public double[][] obtenerPensionadosTempFinalAnio(double[] penTempMitadAnio,
                                                      double[] probMteInv,
                                                      double   ERtempDef73){

        //La longitud de la matriz es de Constantes.ANIOS_PROYECCION ya que es 1 año mas q las defintivas
        double[][] penTempFinAnio = new double[Constantes.ANIOS_PROYECCION][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];

        //Para el primer Año de proyección
        for(int edad=1;edad<=penTempMitadAnio.length;edad++){
            penTempFinAnio[0][edad]=penTempMitadAnio[edad-1]*((2*(1-probMteInv[edad-1]))/(1+(1-probMteInv[edad-1])));
        }
        //Para el segundo año
        for(int edad=1;edad<penTempFinAnio[0].length;edad++){
                penTempFinAnio[1][edad]=penTempFinAnio[0][edad-1]*(1-probMteInv[edad-1]);
        }
        //Para el tercer año
            for(int edad=1;edad<penTempFinAnio[0].length;edad++){
               penTempFinAnio[2][edad]=penTempFinAnio[1][edad]*((1+(1-probMteInv[edad]))/2D)*ERtempDef73;
            }
        //Para el cuarto año
            for(int edad=1;edad<penTempFinAnio[0].length;edad++){
               penTempFinAnio[3][edad]=penTempFinAnio[2][edad-1]*((2*(1-probMteInv[edad-1]))/(1+(1-probMteInv[edad-1])));
            }
        //Para los demas años
        for(int año =4;año<penTempFinAnio.length;año++){
            for(int edad=1;edad<penTempFinAnio[0].length;edad++){
                penTempFinAnio[año][edad]=penTempFinAnio[año-1][edad-1]*(1-probMteInv[edad-1]);
            }
        }

        this.pensionadosTempFinalAnio = penTempFinAnio;
        return penTempFinAnio;
    }

    /********************************************************************************************
     * Este método obtiene a los pensionados que que fallecen en cada año de proyección.        *
     * @param penSobFinalAnio: Pensionados que sobreviven al final del año.                     *
     * @param penMitadAnio: Nuevos pensionados que ingresarón a mitad del año.                  *
     * @param probMteInv: Probabilidad de que un pensionado fallezca.                           *
     * @return pensFallecidos: Pensionados que fallecen en cada año.                            *
     ********************************************************************************************/
    public double[][] obtenerPensionadosFallecidos(double[][] penSobFinalAnio,
                                                   double[][] probMte,
                                                   double[] penMitadAnio,
                                                   String pension) {

        double[][] pensFallecidos = new double[penSobFinalAnio.length][penSobFinalAnio[0].length];
        boolean bandera = (pension.equals("ceve") ? false : true);//utilizo prob de activos o de inc/inv

        //Para el primer Año de proyección
        for (int edad = 1; edad <= penMitadAnio.length; edad++) {

            pensFallecidos[0][edad] = penMitadAnio[edad - 1] * (1 - ((2 * (1 - probMte[0][(bandera ? edad - 1 : edad + 14)])) / (1 + (1 - probMte[0][(bandera ? edad - 1 : edad + 14)]))));
        }

        //Para los demas años
        for (int año = 1; año < pensFallecidos.length; año++) {
            for (int edad = 1; edad < pensFallecidos[0].length; edad++) {

                pensFallecidos[año][edad] = penSobFinalAnio[año - 1][edad - 1] * probMte[(bandera ? 0 : año)][(bandera ? edad - 1 : edad + 14)];
            }
        }
        this.pensionadosFallecidos = pensFallecidos;
        return pensFallecidos;
    }

    /**
     * Pensionados fallecidos de pensiones temporales
     */


    public double[][] obtenerPensTempFallecidos(double[][] penTempSobFinalAnio,
                                                double[] penTempMitadAnio,
                                                double[] probMteInv,
                                                double[] ERMteL73,
                                                int anioProy){

        double[][] pensFallecidosTemp = new double[penTempSobFinalAnio.length][penTempSobFinalAnio[0].length];

        //Para el primer Año de proyección
        for(int edad=1;edad<=penTempMitadAnio.length;edad++){
            pensFallecidosTemp[0][edad]=penTempMitadAnio[edad-1]*(1-((2*(1-probMteInv[edad-1]))/(1+(1-probMteInv[edad-1]))))*ERMteL73[(anioProy<ERMteL73.length?anioProy:ERMteL73.length-1)];//anioProy
        }
        //Para el segundo año
        for(int edad=1;edad<penTempSobFinalAnio[0].length;edad++){
            pensFallecidosTemp[1][edad]=penTempSobFinalAnio[0][edad-1]*(1-(1-probMteInv[edad-1]))*ERMteL73[(anioProy+1<ERMteL73.length?anioProy+1:ERMteL73.length-1)];
        }
        //Para el tercer año
        for(int edad=1;edad<penTempSobFinalAnio[0].length;edad++){
            pensFallecidosTemp[2][edad]=penTempSobFinalAnio[1][edad]*(1-(1+(1-probMteInv[edad]))/2D)*ERMteL73[(anioProy+2<ERMteL73.length?anioProy+2:ERMteL73.length-1)];
        }
        //Para el cuarto año
        for(int edad=1;edad<penTempSobFinalAnio[0].length;edad++){
            pensFallecidosTemp[3][edad]=penTempSobFinalAnio[2][edad-1]*(1-((2*(1-probMteInv[edad-1]))/(1+(1-probMteInv[edad-1]))))*ERMteL73[(anioProy+2<ERMteL73.length?anioProy+2:ERMteL73.length-1)];
        }
        //Para los demas años
        for(int año=4;año<penTempSobFinalAnio.length;año++){
            for(int edad=1;edad<penTempSobFinalAnio[0].length;edad++){
                pensFallecidosTemp[año][edad]=penTempSobFinalAnio[año-1][edad-1]*probMteInv[edad-1]*ERMteL73[(año-1+anioProy<ERMteL73.length?año-1+anioProy:ERMteL73.length-1)];//año-1+anioProy
            }
        }
        this.pensionadosTempFallecidos = pensFallecidosTemp;
        return pensFallecidosTemp;
    }


    /****************************************************************************************************
     * Este método obtiene las nuevas viudas, huefanos y ascendientes en cada año de proyección.        *
     * @param pensFalle: Pensionados que fallecen en cada año.                                          *
     * @param distDerivadas: Distribución de viudas, huefanos o ascendientes.                           *
     * @return nuevasDerivadas: Nuevas pensiones de viudez, orfandad y ascendencia en cada año.         *
     ****************************************************************************************************/
    public double[][] obtenerNvasViuHuerAscCdaAñoProyeccion(double[][] pensFalle,
                                                            double[][] distDerivadas){

        double[][] nuevasDerivadas = new double[pensFalle.length][pensFalle[0].length];
        //Creamos objeto que se necesita para realizar operaciones matematicas
        FuncionesMatematicas fm = new FuncionesMatematicas();

        for(int año=0;año<pensFalle.length;año++){
            for(int edad=0;edad<pensFalle[0].length;edad++){
                nuevasDerivadas[año][edad]= fm.sumaProducto(pensFalle[año], distDerivadas[edad]);
            }
        }

        return nuevasDerivadas;

    }



    public double[][] obtenerNvasViuHuerAscTempCdaAñoProyeccion(double[][] pensTempFalle,
                                                                double[][] distDerivadas){

        double[][] nuevasDerivadas = new double[pensTempFalle.length-1][pensTempFalle[0].length];
        //Creamos objeto que se necesita para realizar operaciones matematicas
        FuncionesMatematicas fm = new FuncionesMatematicas();

        for(int año=0;año<=1;año++){//Para el primer y segundo año
            for(int edad=0;edad<pensTempFalle[0].length;edad++){
                nuevasDerivadas[año][edad]= fm.sumaProducto(pensTempFalle[año], distDerivadas[edad]);
            }
        }

        //Para el tercer año
            for(int edad=0;edad<pensTempFalle[0].length;edad++){
                nuevasDerivadas[2][edad]= fm.sumaProducto(pensTempFalle[2], distDerivadas[edad]) + fm.sumaProducto(pensTempFalle[3], distDerivadas[edad]);
            }

        //Para los demas años
        for(int año=3;año<pensTempFalle.length-1;año++){//Para el tercer año
            for(int edad=0;edad<pensTempFalle[0].length;edad++){
                nuevasDerivadas[año][edad]= fm.sumaProducto(pensTempFalle[año+1], distDerivadas[edad]);
            }
        }

        return nuevasDerivadas;

    }

    /***************************************************************************************************************
     * Este método obtiene las nuevas viudas, huefanos y ascendientes que fallecen en el año.                      *
     * @param nuevasViuHuerAsc: Nuevas viudas, huerfanos y ascendientes en cada año.                               *
     * @param probActivosyHuerf: Probabilidades de fallecimiento para viudez, huefanos y ascendientes.             *
     * @param esProbAct: Bandera que indica si las probabilidades son para viudas y ascendientes o para huerfanos. *
     * @return viuHuerAscFallecenSegMtadAnio: Nuevas viudas, huerfanos y ascendientes fallecidos en el año.        *
     ***************************************************************************************************************/
    public double[][] obtenerViuHuerAscFallecenSegundaMitadAnio(double[][] nuevasViuHuerAsc,
                                                                double[][] probActivosyHuerf,
                                                                boolean    esProbAct,
                                                                boolean    esMuerte){

        double[][] viuHuerAscFallecenSegMtadAnio= new double[nuevasViuHuerAsc.length][nuevasViuHuerAsc[0].length];

            for (int año = (esMuerte?0:1); año < viuHuerAscFallecenSegMtadAnio.length; año++) {
                for (int edad = 0; edad < viuHuerAscFallecenSegMtadAnio[0].length; edad++) {
                    viuHuerAscFallecenSegMtadAnio[año][edad] = nuevasViuHuerAsc[año][edad]
                            * (esProbAct == true ?
                            (1 - ((2 * (1 - probActivosyHuerf[año][edad + 15])) / (1 + (1 - probActivosyHuerf[año][edad + 15])))) :                              
                            (1 - ((2 * probActivosyHuerf[año][edad]) / (1 + probActivosyHuerf[año][edad])))                              
                            );
                }
            }
            return viuHuerAscFallecenSegMtadAnio;

    }

    /*****************************************************************************************************************
     * Este método obtiene las nuevas viudas, huefanos y ascendientes que sobreviven en el año.                      *
     * @param nvasViuHuerfAsc: Nuevas viudas, huerfanos y ascendientes en el año.                                    *
     * @param probMteActySobHuerf: Probabilidades de fallecimiento para viudez, huefanos y ascendientes.             *
     * @param esProbAct: Bandera que indica si las probabilidades son para viudas y ascendientes o para huerfanos.   *
     * @return viudasHuerfAscSobFinalAnio: Nuevas viudas, huerfanos y ascendientes que sobreviven en el año.         *
     *****************************************************************************************************************/
    public double[][] obtenerViuHuerAscSobFinalAño(double[][] nvasViuHuerfAsc,
                                                   double[][] probMteActySobHuerf,
                                                   boolean    esProbAct,
                                                   boolean    esMuerte){

        double[][] viudasHuerfAscSobFinalAnio= new double[nvasViuHuerfAsc.length][nvasViuHuerfAsc[0].length];

        //Para el primer año
        viudasHuerfAscSobFinalAnio[0]=nvasViuHuerfAsc[0];

        //Para los demas años
            for (int año = (esMuerte?0:1); año < viudasHuerfAscSobFinalAnio.length; año++) {
                for (int edad = 0; edad < viudasHuerfAscSobFinalAnio[0].length; edad++) {
                    viudasHuerfAscSobFinalAnio[año][edad] = nvasViuHuerfAsc[año][edad]
                            * ( esProbAct == true ?
                              ((2 * (1 - probMteActySobHuerf[año][edad + 15])) / (1 + (1 - probMteActySobHuerf[año][edad + 15]))) :
                              ((2 * probMteActySobHuerf[año][edad]) / (1 + probMteActySobHuerf[año][edad]))
                              );
                }
            }
            return viudasHuerfAscSobFinalAnio;
    }

    /******************************************************************************************************************
     * Este método obtiene las viudas, huefanos y ascendientes que sobreviven en cada año de proyección.              *
     * @param viuHuerAscSobFinalAnio: Nuevas viudas, huerfanos y ascendientes que sobreviven en el año.               *
     * @param probMteActySobHuerf: Probabilidades de fallecimiento para viudez, huefanos y ascendientes.              *
     * @param esProbAct: Bandera que indica si las probabilidades son para viudas y ascendientes o para huerfanos.    *
     * @return viudasHuerAscSobCadaAnio: Viudas, huerfanos y ascendientes que sobreviven en cada año de proyección.   *
     ******************************************************************************************************************/
    public double[][] obtenerViuHuerAscSobCadaAnio(double[][] viuHuerAscSobFinalAnio,
                                                   double[][] probMteActySobHuerf,
                                                   boolean esProbAct){
        
        double[][] viudasHuerAscSobCadaAnio= new double[viuHuerAscSobFinalAnio.length][viuHuerAscSobFinalAnio[0].length];
        
        //Para el primer año
        viudasHuerAscSobCadaAnio[0] = viuHuerAscSobFinalAnio[0];
        
        //Para el segundo año
            for(int edad=1;edad<viudasHuerAscSobCadaAnio[0].length;edad++){
                viudasHuerAscSobCadaAnio[1][edad]=viuHuerAscSobFinalAnio[0][edad-1]*(esProbAct==true?(1-probMteActySobHuerf[1][edad+14]):probMteActySobHuerf[1][edad-1]);
            }

        //Para los demas años
        for(int año=2;año<viudasHuerAscSobCadaAnio.length;año++){
            for(int edad=1;edad<viudasHuerAscSobCadaAnio[0].length;edad++){
                viudasHuerAscSobCadaAnio[año][edad]=(viudasHuerAscSobCadaAnio[año-1][edad-1] + viuHuerAscSobFinalAnio[año-1][edad-1]) *
                                              (esProbAct==true?(1-probMteActySobHuerf[año][edad+14]):probMteActySobHuerf[año][edad-1]);
            }
        }
        return viudasHuerAscSobCadaAnio;
        
    }


    /********************************************************************************************************************
     * Este método obtiene las viudas, huefanos y ascendientes que fallecen en cada año de proyección.                  *
     * @param viuHuerAscSobFinalAnio: Nuevas viudas, huerfanos y ascendientes que sobreviven en el año.                 *
     * @param viuHuerAscSobCadaAnio: Viudas, huerfanos y ascendientes que sobreviven en cada año de proyección.         *
     * @param probMteActySobHuerf: Probabilidades de fallecimiento para viudez, huefanos y ascendientes.                *
     * @param esProbAct: Bandera que indica si las probabilidades son para viudas y ascendientes o para huerfanos.      *
     * @return viudasHuerAscFallecenCadaAnio: Viudas, huerfanos y ascendientes que fallecen en cada año de proyección.  *
     ********************************************************************************************************************/
    public double[][] obtenerViuHuerAscFallecenCadaAnio(double[][] viuHuerAscSobFinalAnio,
                                                        double[][] viuHuerAscSobCadaAnio,
                                                        double[][] probMteActySobHuerf,
                                                        boolean    esProbAct){

        double[][] viudasHuerAscFallecenCadaAnio= new double[viuHuerAscSobCadaAnio.length][viuHuerAscSobCadaAnio[0].length];

        //Para el primer año
            for(int edad=1;edad<viudasHuerAscFallecenCadaAnio[0].length;edad++){
                viudasHuerAscFallecenCadaAnio[1][edad]=viuHuerAscSobFinalAnio[0][edad-1]*(esProbAct==true? probMteActySobHuerf[1][edad+14]:(1-probMteActySobHuerf[1][edad-1]));
            }

        //Para los demas años
        for(int año=2;año<viudasHuerAscFallecenCadaAnio.length;año++){
            for(int edad=1;edad<viudasHuerAscFallecenCadaAnio[0].length;edad++){
            
                viudasHuerAscFallecenCadaAnio[año][edad]=(viuHuerAscSobFinalAnio[año-1][edad-1] + viuHuerAscSobCadaAnio[año-1][edad-1]) *
                                              (esProbAct==true?probMteActySobHuerf[año][edad+14]:(1-probMteActySobHuerf[año][edad-1]));
            }
        }
        return viudasHuerAscFallecenCadaAnio;

    }



    /**********************************************************************************************************************
     * Este método obtiene las probabilidades que se utilizan en la sobrevivencia de viudas, huerfanos y ascendientes.    *
     * @param probMteAct: Probabilidades de muerte de activos de acuerdo a la edad y año.                                 *
     * @param tasaMejora: Tasa de mejora de acuerdo a la edad.                                                            *
     * @param tasaDesercion: Tasa de deserción para huerfanos.                                                            *
     **********************************************************************************************************************/
    public void obtenerProbActivosyHuerfanos(double[] probMteAct,
                                             double[] tasaMejora,
                                             double[] tasaDesercion,
                                             boolean  esCeVe){

        double[][] probActMte = new double[Constantes.ANIOS_PROYECCION-1][Constantes.EDAD_MAX_PROYECTADA + 1];
        double[][] probHuerf = new double[Constantes.ANIOS_PROYECCION-1][Constantes.EDAD_MAX_PROYECTADA + 1];

        //Obtenemos las probabilidades de activos

        //Para el primer año de proyeccion.
        for (int edad = 0; edad < probActMte[0].length; edad++) {
            probActMte[0][edad] = probMteAct[edad] * Math.pow((1 - tasaMejora[edad]), 1);//Eleva a la 1 por el primer año
        }
        //Para los demas años a proyectar
        for (int años = 1; años < probActMte.length; años++) {
            for (int edad = 0; edad < probActMte[0].length; edad++) {
                probActMte[años][edad] = probMteAct[edad] * Math.pow((1 - tasaMejora[edad]), años + 1);
            }
        }
        if(esCeVe){
            this.probActivosMteCeVe = probActMte;
        }else{
            this.probActivosMte = probActMte;
        }

        //Obtenemos las probabilidades para huerfanos
        if(!esCeVe){
            for (int años = 0; años < probHuerf.length; años++) {
                for (int edad = 0; edad <=24; edad++) {
                    probHuerf[años][edad] = 1- (probActMte[años][edad] * (1-(tasaDesercion[edad])/2D));
                }
            }
            this.probHuefanos = probHuerf;
        }        
}
 
    public double[][] getAseguradosVigentes() {
        return aseguradosVigentes;
    }

    public double[][] getAseguradosCotizan() {
        return aseguradosCotizan;
    }

    public double[][] getAseguradosNoCotizan() {
        return aseguradosNoCotizan;
    }

    public double[][] getProbActivosMte() {
        return probActivosMte;
    }

    public double[][] getProbHuefanos() {
        return probHuefanos;
    }

    public double[][] getPensionadosMitadAnio() {
        return pensionadosMitadAnio;
    }

    public double[][] getPensionadosFallecidos() {
        return pensionadosFallecidos;
    }

    public double[][] getPensionadosFinalAnio() {
        return pensionadosFinalAnio;
    }

    public double[][] getNuevasViudasCadaAnio() {
        return nuevasViudasCadaAnio;
    }

    public double[][] getViudasSobrevivenCadaAnio() {
        return viudasSobrevivenCadaAnio;
    }

    public double[][] getViudasSobrevivenFinalAnio() {
        return viudasSobrevivenFinalAnio;
    }

    public double[][] getNuevasviudasFallecenMitadAnio() {
        return nuevasviudasFallecenMitadAnio;
    }

    public double[][] getViudasFallecenCadaAnio() {
        return viudasFallecenCadaAnio;
    }

    public double[][] getAscendientesFallecenCadaAnio() {
        return ascendientesFallecenCadaAnio;
    }

    public double[][] getAscendientesSobrevivenCadaAnio() {
        return ascendientesSobrevivenCadaAnio;
    }

    public double[][] getAscendientesSobrevivenFinalAnio() {
        return ascendientesSobrevivenFinalAnio;
    }

    public double[][] getHuerfanosFallecenCadaAnio() {
        return huerfanosFallecenCadaAnio;
    }

    public double[][] getHuerfanosSobrevivenCadaAnio() {
        return huerfanosSobrevivenCadaAnio;
    }

    public double[][] getHuerfanosSobrevivenFinalAnio() {
        return huerfanosSobrevivenFinalAnio;
    }

    public double[][] getNuevosAscendientesCadaAnio() {
        return nuevosAscendientesCadaAnio;
    }

    public double[][] getNuevosAscendientesFallecenMitadAnio() {
        return nuevosAscendientesFallecenMitadAnio;
    }

    public double[][] getNuevosHuerfanosCadaAnio() {
        return nuevosHuerfanosCadaAnio;
    }

    public double[][] getNuevosHuerfanosFallecenMitadAnio() {
        return nuevosHuerfanosFallecenMitadAnio;
    }

    public double[] getTotalPensionadosVigentesCeve() {
        return totalPensionadosVigentesCeve;
    }

    public double[] getTotalPensionadosVigentesInv() {
        return totalPensionadosVigentesInv;
    }

    public double[] getTotalPensionesAscendenciaVigentesCeve() {
        return totalPensionesAscendenciaVigentesCeve;
    }

    public double[] getTotalPensionesAscendenciaVigentesInv() {
        return totalPensionesAscendenciaVigentesInv;
    }

    public double[] getTotalPensionesOrfandadVigentesCeve() {
        return totalPensionesOrfandadVigentesCeve;
    }

    public double[] getTotalPensionesOrfandadVigentesInv() {
        return totalPensionesOrfandadVigentesInv;
    }

    public double[] getTotalPensionesViudezVigentesCeve() {
        return totalPensionesViudezVigentesCeve;
    }

    public double[] getTotalPensionesViudezVigentesInv() {
        return totalPensionesViudezVigentesInv;
    }

    public double[][] getProbActivosMteCeVe() {
        return probActivosMteCeVe;
    }

    public double[] getTotalPensionesAscendenciaVigentesMte() {
        return totalPensionesAscendenciaVigentesMte;
    }

    public double[] getTotalPensionesOrfandadVigentesMte() {
        return totalPensionesOrfandadVigentesMte;
    }

    public double[] getTotalPensionesViudezVigentesMte() {
        return totalPensionesViudezVigentesMte;
    }

    public double[] getTotalPensionadosVigentesIP100() {
        return totalPensionadosVigentesIP100;
    }

    public double[] getTotalPensionesAscendenciaVigentesIP100() {
        return totalPensionesAscendenciaVigentesIP100;
    }

    public double[] getTotalPensionesOrfandadVigentesIP100() {
        return totalPensionesOrfandadVigentesIP100;
    }

    public double[] getTotalPensionesViudezVigentesIP100() {
        return totalPensionesViudezVigentesIP100;
    }

    public double[] getTotalPensionadosVigentesIPMenor100() {
        return totalPensionadosVigentesIPMenor100;
    }

    public double[] getTotalPensionesAscendenciaVigentesIPMenor100() {
        return totalPensionesAscendenciaVigentesIPMenor100;
    }

    public double[] getTotalPensionesOrfandadVigentesIPMenor100() {
        return totalPensionesOrfandadVigentesIPMenor100;
    }

    public double[] getTotalPensionesViudezVigentesIPMenor100() {
        return totalPensionesViudezVigentesIPMenor100;
    }

    public double[] getTotalPensionadosVigentesIPMenor50() {
        return totalPensionadosVigentesIPMenor50;
    }

    public double[] getTotalPensionesAscendenciaVigentesIPMenor50() {
        return totalPensionesAscendenciaVigentesIPMenor50;
    }

    public double[] getTotalPensionesOrfandadVigentesIPMenor50() {
        return totalPensionesOrfandadVigentesIPMenor50;
    }

    public double[] getTotalPensionesViudezVigentesIPMenor50() {
        return totalPensionesViudezVigentesIPMenor50;
    }

    /**************************
     *      Temporales        *
     **************************/

   
    public double[] getTotalPensionadosVigentesInvTemp() {
        return totalPensionadosVigentesInvTemp;
    }

    

    public double[] getTotalPensionesAscendenciaVigentesInvTemp() {
        return totalPensionesAscendenciaVigentesInvTemp;
    }

   

    public double[] getTotalPensionesOrfandadVigentesInvTemp() {
        return totalPensionesOrfandadVigentesInvTemp;
    }

    

    public double[] getTotalPensionesViudezVigentesInvTemp() {
        return totalPensionesViudezVigentesInvTemp;
    }

    public double[][] getPensionadosTempFallecidos() {
        return pensionadosTempFallecidos;
    }

    public double[][] getPensionadosTempFinalAnio() {
        return pensionadosTempFinalAnio;
    }

    public double[] getPensionadosSobAnioCompInvTemp() {
        return pensionadosSobAnioCompInvTemp;
    }

    public double[] getPensionadosTemDefFinaAnioInvTemp() {
        return pensionadosTemDefFinaAnioInvTemp;
    }

    public double[] getPensionadosTemDefInvTemp() {
        return pensionadosTemDefInvTemp;
    }

    public double[] getPensionadosSobAnioCompIP100Temp() {
        return pensionadosSobAnioCompIP100Temp;
    }

    public double[] getPensionadosSobAnioCompIPMenor100Temp() {
        return pensionadosSobAnioCompIPMenor100Temp;
    }

    public double[] getPensionadosSobAnioCompIPMenor50Temp() {
        return pensionadosSobAnioCompIPMenor50Temp;
    }

    public double[] getPensionadosTemDefFinaAnioIP100Temp() {
        return pensionadosTemDefFinaAnioIP100Temp;
    }

    public double[] getPensionadosTemDefFinaAnioIPMenor100Temp() {
        return pensionadosTemDefFinaAnioIPMenor100Temp;
    }

    public double[] getPensionadosTemDefFinaAnioIPMenor50Temp() {
        return pensionadosTemDefFinaAnioIPMenor50Temp;
    }

    public double[] getPensionadosTemDefIP100Temp() {
        return pensionadosTemDefIP100Temp;
    }

    public double[] getPensionadosTemDefIPMenor100Temp() {
        return pensionadosTemDefIPMenor100Temp;
    }

    public double[] getPensionadosTemDefIPMenor50Temp() {
        return pensionadosTemDefIPMenor50Temp;
    }

    public double[][] getPensionadosTempMitadAnio() {
        return pensionadosTempMitadAnio;
    }

    public double[] getTotalPensionadosVigentesIP100Temp() {
        return totalPensionadosVigentesIP100Temp;
    }

    public double[] getTotalPensionadosVigentesIPMenor100Temp() {
        return totalPensionadosVigentesIPMenor100Temp;
    }

    public double[] getTotalPensionadosVigentesIPMenor50Temp() {
        return totalPensionadosVigentesIPMenor50Temp;
    }

    public double[] getTotalPensionesAscendenciaVigentesIP100Temp() {
        return totalPensionesAscendenciaVigentesIP100Temp;
    }

    public double[] getTotalPensionesAscendenciaVigentesIPMenor100Temp() {
        return totalPensionesAscendenciaVigentesIPMenor100Temp;
    }

    public double[] getTotalPensionesAscendenciaVigentesIPMenor50Temp() {
        return totalPensionesAscendenciaVigentesIPMenor50Temp;
    }

    public double[] getTotalPensionesOrfandadVigentesIP100Temp() {
        return totalPensionesOrfandadVigentesIP100Temp;
    }

    public double[] getTotalPensionesOrfandadVigentesIPMenor100Temp() {
        return totalPensionesOrfandadVigentesIPMenor100Temp;
    }

    public double[] getTotalPensionesOrfandadVigentesIPMenor50Temp() {
        return totalPensionesOrfandadVigentesIPMenor50Temp;
    }

    public double[] getTotalPensionesViudezVigentesIP100Temp() {
        return totalPensionesViudezVigentesIP100Temp;
    }

    public double[] getTotalPensionesViudezVigentesIPMenor100Temp() {
        return totalPensionesViudezVigentesIPMenor100Temp;
    }

    public double[] getTotalPensionesViudezVigentesIPMenor50Temp() {
        return totalPensionesViudezVigentesIPMenor50Temp;
    }

    

    

    

    

    
    

    

    

    



    

    

    

    

    



    

    

    

    

    

    

    

    






}
